<?php
	// security check
	require_once "secureLogin.php";
	require_once "cmvar.php";

	// 20090518 - Remove Start, add Premium
	// version control
	if (substr_count(strtolower($version), 'premium') > 0  || substr_count(strtolower($version), 'standard') > 0) {
		if (substr_count(strtolower($version),'donation')>0)
			$version = substr($version,0,strlen($version)-9);
		$disabled = ' disabled';
		$version_msg = '* This feature is not available in '. ucwords($version) .' Edition.';
		$version_star = '<span class="star">* </span>';
	} else {
		$disabled = '';
		$version_msg = '';
		$version_star = '';
	}

	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');

	if( !isset($FOMode) )
		$FOMode=$settingobj->getKey('mode', 'FSFO');

	if( $FOMode == '' )
		$FOMode = 0;


	$currMachineID	= $settingobj->getKey('MachineID', 'FSFO');

	$FSFO_Port		= $settingobj->getKey('Port', 'FSFO');
	$FSFO_Interval	= $settingobj->getKey('interval', 'FSFO');
	if( $FSFO_Interval!='' )
		$FSFO_Interval = $FSFO_Interval/1000;

	$upOnly			= (strtolower($settingobj->getKey('scratch_login', 'gateway')) == 'off');
	$upOnly			= $upOnly && (strtolower($settingobj->getKey('username_plus_scratch_login', 'gateway')) == 'off');
	$upOnly			= $upOnly && (strtolower($settingobj->getKey('anonymous_login', 'gateway')) == 'off');

	$scenario2		= $settingobj->getKey('scenario2', 'gateway');

	$totalFS		= $settingobj->getKey('TotalFS', 'FSFO');
	if($totalFS =='' || $totalFS < 2 || $totalFS > $totalFS_max)
		$totalFS = 2;
	$myFSNum		= $settingobj->getKey('MyFSNum', 'FSFO');
	if($myFSNum =='' || $myFSNum < 1 || $myFSNum > $totalFS)
		$myFSNum = 1;
	$DelayT			= $settingobj->getKey('DelayTime', 'FSFO');
	if($DelayT != '' && ($DelayT < $FODelay_min || $DelayT > $FODelay_max))
		$DelayT = '';

	$settingobj=null;

	$defaultDisplay = 'none'; // Main Machine
	$defaultDisplay1 = 'none'; // Backup Machine
	$defaultDisplay2 = 'none'; // common eg. port, HeartBeat Interval
	$defaultDisplay3 = 'none'; // Load balancing
	$defaultDisplay4 = 'none'; // DHCP Delay
	$backupModeDisplay = 'none'; // eg. Back Mode

	if( $FOMode == 1){ // Main Machine
		$defaultDisplay = '';
		$defaultDisplay2 = '';
	}else if( $FOMode == 2 ){ // Backup Machine
		$defaultDisplay1 = '';
		$defaultDisplay2 = '';
		$backupModeDisplay = '';
	}else if( $FOMode == 3){ // using Load Balancing
		$defaultDisplay2 = '';
		$defaultDisplay3 = '';
	}else if( $FOMode == 4){ // DHCP Delay
		$defaultDisplay4 = '';
	}

?>
<script type="text/javascript" src="./javascript/FO.js"></script>

<form name="c_FO" action="settingok.php" method="post" onSubmit="return validate_fo()">
<!-- FailOver Header -->
<?
	gen_license_warning($version_msg);

	// Mode Selection
	// Load Balancing not allow enable Scenario2
	$input=
	'<input type="hidden"  id="FOSII_d" name="FOSII_d" '.($FOMode!=4? "" : "disabled").'>'.
	'<input type="radio" name="fo_mode" id="fo_mode_0" value="0" '.($FOMode==0? "checked" : "").' onClick="switchFOMode(this)">'.get_cm_var('setcfg_failover_mode0').
	'<br><input type="radio" '. $disabled .' name="fo_mode" id="fo_mode_4" value="4" '.($FOMode==4? "checked" : "").' onclick="switchFOMode(this);">'.get_cm_var('setcfg_failover_mode4').
	'<br>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" '.($FOMode==4? '' : 'disabled').' id="FOSII" name="FOSII" value="0" onclick="'.($upOnly?'this.value=1; switchFOSIIMode();':'alert(\''.get_cm_var('js_alert_failover_28').'\');return false').'" '.($scenario2?"checked":"").' >'.get_cm_var('setcfg_failover_scenario2').
	'<br>';

	gen_line($version_star.get_cm_var('setcfg_failover_mode'),$input);

	gen_invisible_sep( 'sep8a', $defaultDisplay4 );

	$count = 2;
	$input='<select name="totalFS" onchange="changeMNoOptions(this.value)">';
	while($count <= $totalFS_max){
		$input.="<option value=\"$count\"".(($count==$totalFS)?" selected":"").">$count</option>";
		$count++;
	}
	$input.="</select>";
	gen_invisible_line($version_star.get_cm_var('setcfg_failover_totalFS'), $input, 'FSFOTotalFS', $defaultDisplay4);

	gen_invisible_sep( 'sep8b', $defaultDisplay4 );

	$count = 1;
	$input='<select name="myFSNum" id="myFSNum">';
	while($count <= $totalFS){
		$input.="<option value=\"$count\"".(($count==$myFSNum)?" selected":"").">$count</option>";
		$count++;
	}
	$input.="</select>";
	gen_invisible_line($version_star.get_cm_var('setcfg_failover_myFSNum'), $input, 'FSFOMyFSNum', $defaultDisplay4);

	gen_invisible_sep( 'sep8c', $defaultDisplay4 );

	$input='<input class="shorttextbox" type="text" '.$disabled.' name="delaytime" maxlength="5" value="'.$DelayT.'" onKeyPress="return numbersonly(this,event)" onfocus="this.select()"><br/>'.$version_star.get_cm_var('setcfg_failover_delayTime_msg');
	gen_invisible_line($version_star.get_cm_var('setcfg_failover_delayTime'), $input, 'FSFODelayTime', $defaultDisplay4);

	gen_invisible_sep( 'sep8d', $defaultDisplay4 );

	// clear message checkbox
	$input = '<input type="checkbox" '.($scenario2 ? $disabled : "disabled").' name="clearMessage" value="true" onclick="if (document.c_FO.clearMessage.checked) alert(\''.get_cm_var('setcfg_auth_clear_message_table_remind').'\')">'.get_cm_var('setcfg_auth_clear_message_table');

	gen_invisible_line(get_cm_var('setcfg_failover_clear_message'), $input, 'clear_Message_table', $defaultDisplay4);


	gen_sep();

	if (isset($_SERVER['HTTP_REFERER']))
		search_scroll($HTTP_REFERER);

	/*gen_save2('c_FO','c_FO_save','c_FO_cancel');*/
	gen_save('save_fo',$fs_status);
?>
