<?php
/**
 *  Allow admins to edit the content of default language file
 *  Notes:
 *      All the changes will be saved in $lang_pack_file, not in the actual default file
 */

// check access right
require_once "secureLogin.php";

require_once "form_elements.php";

// get input value
function get_input_var($element)
{
    global $lang;

	// 20090615 - Decode characters
	return (isset($lang[$element])? html_entity_decode($lang[$element], ENT_NOQUOTES) : '');
}
function get_ln($element)
{
    return '<input class="longtextbox" type="text" name="'.$element.'" value="'.get_input_var($element).'"  onfocus="this.select()">';
}
// for extra information fields only
function get_ln_extra($element, $checkbox)
{
    return '<input class="longtextbox" type="text" name="'.$element.'" value="'.get_input_var($element)."\" onKeyUp=\"checkRequire(this, '$checkbox');\" onfocus=\"this.select()\">";
}
function get_checkbox_extra($element, $checkbox)
{
    if(($GLOBALS["settingobj"]->getKey($checkbox , "lang"))=="on")
        return '<input type="checkbox" name="'.$checkbox.'" checked="checked" value="on">';
    else {
        if(get_input_var($element) == '')
            return '<input type="checkbox" name="'.$checkbox.'" disabled value="on">';
        else
            return '<input type="checkbox" name="'.$checkbox.'" value="on">';
    }
}

// 20080430
function get_textarea($element)
{
	// 20100430 - Change retrieving in PHP
	return '<textarea class="standard" name="'.$element.'" onfocus="this.select()">'.get_input_var($element).'</textarea>';
}

function gen_invisible_select($id, $textTitle, $sel_opt_Arr, $selVal, $trid, $defaultDisplay)
{

	$content = "";
	
	$content .= '
	<tr id="'.$trid.'" style="display:'.$defaultDisplay.'">
		<td width="400" valign="top"><p class="indented">
			<img src="./images/blank.gif" width="19" height="8">'.$textTitle.'
		</p></td>
	    <td width="50"><img src="./images/blank.gif" width="3" height="3"></td>
		<td width="300" class="normal">
			';
			
			// select (font)
			$content .='
				<select name="'.$id.'">
			';
			
			$sel_cont="";
			
			$isSelected = false;
			
			foreach($sel_opt_Arr as $optVal){
				$tmp_sub = "";
				
				// $valArr[$k]
				
				if ( $selVal == $optVal){
					$tmp_sub = 'selected="selected"';
					$isSelected = true;
				}
				$sel_cont.='<option value="'.$optVal.'" '.$tmp_sub.' >'.$optVal.'</option>';
			}
			
			if ($isSelected)
				$sel_cont='<option value=""></option>'.$sel_cont;
			else
				$sel_cont='<option value="" selected="selected"></option>'.$sel_cont;
				
			$content .= $sel_cont;
			
			$content .='
				</select>
			';
			
	$content .= '
			</table>
		</td>
	</tr>';
	
	echo $content;
	
}

function gen_invisible_custom_Style($id, $keyArr, $defaultValArr, $valArr, $trid, $defaultDisplay)
{

	$content = "";
	
	$content .= '
	<tr id="'.$trid.'" style="display:'.$defaultDisplay.'">
		<td width="400" valign="top">
		<p class="indented">
			<img src="./images/blank.gif" width="19" height="8">'.get_cm_var('setcfg_ui_custom_style').'
		</p>
		</td>
	    <td width="50"><img src="./images/blank.gif" width="3" height="3"></td>
		<td width="300" class="normal">
			<table>';
			
	foreach($keyArr as $k => $v){
		if (!isset($valArr[$k])){
			$valArr[$k] = "";
		}
		
		if ($v == "font-family"){
			// select (font)
			$content .='
			<tr>
				<td class="normal" valign="top" >'.get_cm_var('setcfg_ui_custom_style_'.$v).'</td>
				<td>
				<select name="'.$id.'_style_'.$v.'" >
			';
			
			$sel_cont="";
			
			// $sel_opt_Arr = array("serif", "sans-serif", "cursive", "fantasy", "monospace");
			$sel_opt_Arr = array("Georgia, serif", "'Palatino Linotype', 'Book Antiqua', Palatino, serif", "'Times New Roman', Times, serif", "Arial, Helvetica, sans-serif", "Arial Black, Gadget, sans-serif", "'Comic Sans MS', cursive, sans-serif", "Impact, Charcoal, sans-serif", "'Lucida Sans Unicode', 'Lucida Grande', sans-serif", "Tahoma, Geneva, sans-serif", "'Trebuchet MS', Helvetica, sans-serif", "Verdana, Geneva, sans-serif", "'Courier New', Courier, monospace", "'Lucida Console', Monaco, monospace");
			
			$isSelected = false;
			$sel_js ="";
			
			foreach($sel_opt_Arr as $optVal){
				$tmp_sub = "";
				
				// $valArr[$k]
				
				if ( html_entity_decode($valArr[$k], ENT_QUOTES) == $optVal){
					$tmp_sub = 'selected="selected"';
					$isSelected = true;
				}
				$sel_cont.='<option value="'.$optVal.'" '.$tmp_sub.' style="font-family:'.$optVal.';">'.str_replace("'","",$optVal).'</option>';
			}
			
			if ($isSelected)
				$sel_cont='<option value="" style="font-family:'.$defaultValArr[$k].';">'.$defaultValArr[$k].' (default)</option>'.$sel_cont;
			else{
				$sel_cont='<option value="" selected="selected" style="font-family:'.$defaultValArr[$k].';">'.$defaultValArr[$k].' (default)</option>'.$sel_cont;
			}
				
			$content .= $sel_cont;
			
			$content .='
				</select>				
				</td>
			</tr>';
		}
		else if ($v == "font-size"){
			// select (number)
			$content .='
			<tr>
				<td class="normal">'.get_cm_var('setcfg_ui_custom_style_'.$v).'</td>
				<td>				
				<select name="'.$id.'_style_'.$v.'" >
			';
			
			$sel_cont="";
			
			$sel_start=5;
			$sel_end=40;
			
			$isSelected = false;
			$sel_js ="";
			
			for($i=$sel_start; $i <= $sel_end; $i++){
				$tmp_sub = "";
				if ($valArr[$k] == $i."pt"){
					$tmp_sub = 'selected="selected"';
					$isSelected = true;
				}
				$sel_cont.='<option value="'.$i.'pt" '.$tmp_sub.'>'.$i.'pt</option>';
			}
			
			if ($isSelected)
				$sel_cont='<option value="">'.$defaultValArr[$k].' (default)</option>'.$sel_cont;
			else{
				$sel_cont='<option value="" selected="selected">'.$defaultValArr[$k].' (default)</option>'.$sel_cont;
			}
				
			$content .= $sel_cont;
			
			$content .='
				</select>				
				</td>
			</tr>'.$sel_js;
		}
		else if ($v == "color"){
			// select (color)
			$content .='
			<tr>
				<td class="normal">'.get_cm_var('setcfg_ui_custom_style_'.$v).'</td>
				<td>
				<select name="'.$id.'_style_'.$v.'" onchange="if (this.value==\'\'){document.getElementById(\''.$id.'_sq\').style.backgroundColor = \''.$defaultValArr[$k].'\';}else{document.getElementById(\''.$id.'_sq\').style.backgroundColor = this.value;}">
			';
			
			$sel_cont="";
			
			$sel_opt_Arr = array("AliceBlue","AntiqueWhite","Aqua","Aquamarine","Azure","Beige","Bisque","Black","BlanchedAlmond","Blue","BlueViolet","Brown","BurlyWood","CadetBlue","Chartreuse","Chocolate","Coral","CornflowerBlue","Cornsilk","Crimson","Cyan","DarkBlue","DarkCyan","DarkGoldenRod","DarkGray","DarkGrey","DarkGreen","DarkKhaki","DarkMagenta","DarkOliveGreen","Darkorange","DarkOrchid","DarkRed","DarkSalmon","DarkSeaGreen","DarkSlateBlue","DarkSlateGray","DarkSlateGrey","DarkTurquoise","DarkViolet","DeepPink","DeepSkyBlue","DimGray","DimGrey","DodgerBlue","FireBrick","FloralWhite","ForestGreen","Fuchsia","Gainsboro","GhostWhite","Gold","GoldenRod","Gray","Grey","Green","GreenYellow","HoneyDew","HotPink","IndianRed","Indigo","Ivory","Khaki","Lavender","LavenderBlush","LawnGreen","LemonChiffon","LightBlue","LightCoral","LightCyan","LightGoldenRodYellow","LightGray","LightGrey","LightGreen","LightPink","LightSalmon","LightSeaGreen","LightSkyBlue","LightSlateGray","LightSlateGrey","LightSteelBlue","LightYellow","Lime","LimeGreen","Linen","Magenta","Maroon","MediumAquaMarine","MediumBlue","MediumOrchid","MediumPurple","MediumSeaGreen","MediumSlateBlue","MediumSpringGreen","MediumTurquoise","MediumVioletRed","MidnightBlue","MintCream","MistyRose","Moccasin","NavajoWhite","Navy","OldLace","Olive","OliveDrab","Orange","OrangeRed","Orchid","PaleGoldenRod","PaleGreen","PaleTurquoise","PaleVioletRed","PapayaWhip","PeachPuff","Peru","Pink","Plum","PowderBlue","Purple","Red","RosyBrown","RoyalBlue","SaddleBrown","Salmon","SandyBrown","SeaGreen","SeaShell","Sienna","Silver","SkyBlue","SlateBlue","SlateGray","SlateGrey","Snow","SpringGreen","SteelBlue","Tan","Teal","Thistle","Tomato","Turquoise","Violet","Wheat","White","WhiteSmoke","Yellow","YellowGreen"
);
			
			$white_text_Arr = array("Black","Blue","BlueViolet","Brown","DarkBlue","DarkCyan","DarkGoldenRod","DarkGray","DarkGreen","DarkKhaki","DarkMagenta","DarkOliveGreen","Darkorange","DarkOrchid","DarkRed","DarkSalmon","DarkSeaGreen","DarkSlateBlue","DarkSlateGray","DarkTurquoise","DarkViolet","Indigo","Maroon","MediumAquaMarine","MediumBlue","MidnightBlue","Navy","Purple");
			
			$isSelected = false;
			$sel_js ="";
			
			foreach($sel_opt_Arr as $optVal){
				$tmp_sub = "";
				
				// $valArr[$k]
				
				if ( html_entity_decode($valArr[$k], ENT_QUOTES) == $optVal){
					$tmp_sub = 'selected="selected"';
					$sel_js="<script>document.getElementById('".$id."_sq').style.backgroundColor = '".$optVal."';</script>";
					$isSelected = true;
				}
				
				$isWhiteColor=false;
				
				if (in_array($optVal, $white_text_Arr)){
					$isWhiteColor=true;
				}
				
				if ($isWhiteColor){
					// white
					$sel_cont.='<option value="'.$optVal.'" '.$tmp_sub.' style="background-color: '.$optVal.';color: #FFFFFF;" >'.$optVal.'</option>';
				}
				else{
					// black
					$sel_cont.='<option value="'.$optVal.'" '.$tmp_sub.' style="background-color: '.$optVal.';color: #000000;" >'.$optVal.'</option>';
				}
			}
			
			$textColor = "#FFFFFF"; // default white
			if (isset($defaultValArr["textColor"]) && $defaultValArr["textColor"] != ""){
				$textColor = $defaultValArr["textColor"];
			}
			
			if ($isSelected)
				$sel_cont='<option value="" style="background-color: '.$defaultValArr[$k].';color: '.$textColor.';" >(default)</option>'.$sel_cont;
			else{
				$sel_cont='<option value="" selected="selected" style="background-color: '.$defaultValArr[$k].';color: '.$textColor.';" >(default)</option>'.$sel_cont;
				if (isset($defaultValArr[$k]) && $defaultValArr[$k] != "")
					$sel_js="<script>document.getElementById('".$id."_sq').style.backgroundColor = '".$defaultValArr[$k]."';</script>";
			}
				
			$content .= $sel_cont;
			
			$content .='
				</select>&nbsp;<span id="'.$id.'_sq" style="border-width: 1px; border-style: solid; border-color: black;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>
				</td>
			</tr>'.$sel_js;
		}
		else{
		}
		
	}
	
	$content .= '
			</table>
		</td>
	</tr>';
	
	echo $content;
	
}

// create COM object
$settingobj = new COM("FSCONFIG.Cfgmgr") or die("setcfg.php FSCONFIG.Cfgmgr Object cannot be created!");

$langdir = "..\\authserv\\lang\\";
$usersettingdir = "..\\usersetting\\";
$default_lang_file = $settingobj->getKey( "default_lang_file", "lang");
$lang_pack_file = $settingobj->getKey( "lang_pack_file", "lang");

// 20090918 - Get control display options
$disable_show_reminder = $settingobj->getKey("disable_show_reminder", "lang");
$disable_show_example = $settingobj->getKey("disable_show_example", "lang");
$disable_show_link = $settingobj->getKey("disable_show_link", "lang");
$disable_show_tc = $settingobj->getKey("disable_show_tc", "lang");

if (!is_file($langdir.$default_lang_file)) {
    gen_sep();
    gen_line('<span class="captionbig" style="color:red;">Language file not found</span>', '');
    gen_sep();
} else {
	ob_start();
    // include default language file
    require_once $langdir.$default_lang_file;
    // include lang pack file
    include_once $usersettingdir.$lang_pack_file;
	ob_end_clean();

    echo '
        <script type="text/javascript" src="./javascript/lang.js"></script>
        <input type="hidden" name="editfile" value="">'."\n";

    //**************************************************************************************
    //  login.php
    //**************************************************************************************
	// 20100430 - Change labels for reminder, links, terms
    // 20090305 - Add label for shared secret input
    // 20080429 - Add terms text
    // 20080424 - Delete cookies row, add term row
    // 20080418 - Add scratch code row
    $var = array(
        'greeting',
        'language',
        'user_name',
        'Password',
	'user_scratch',
        'submit_btn',
        'sign_up_now',
        'anonymous',
	'anonymous_shared_secret',
        'ok_btn',
        'invalid',
        'logged',
        'no_usage',
        'browse_freely',
        'not_support_frames',
        'invalid_access',
    	'reach_conc_limit',
		'login_max_conc',
		'logged_in_other_fs',
		'fail_force_logout_from_other_fs_button',
		'segment_mismatch',
	'ip_login_form_reminder',
	'login_form_reminder',
	'example',
	'free_website',
	'login_form_link',
	'term_condition',
	'login_form_term'
    );
    $cmvar = array(
        'setcfg_ui_login_greeting_msg',
        'setcfg_ui_login_language_field_label',
        'setcfg_ui_login_username_field_label',
        'setcfg_ui_login_password_field_label',
        'setcfg_ui_login_scratch_field_label',
        'setcfg_ui_login_button_label_for_username_password',
        'setcfg_ui_login_caption_for_signup',
        'setcfg_ui_login_add_msg_for_anonymous_mode',
	'setcfg_ui_login_shared_secret_field_label',
        'setcfg_ui_login_btn_label_in_anonymous_mode',
        'setcfg_ui_login_err_msg_for_invalid_username_password',
        'setcfg_ui_login_err_msg_for_duplicate_logins',
        'setcfg_ui_login_err_msg_for_no_timeleft',
        'setcfg_ui_login_win_title_for_exception_free_website',
        'setcfg_ui_login_err_msg_for_browsers_not_support_frames',
	'setcfg_ui_login_err_msg_for_rarely_seen_errors',
	'setcfg_ui_login_warn_msg_for_reach_conc_limit',
	'setcfg_ui_login_err_msg_for_reach_conc_limit',
	'setcfg_ui_login_err_msg_for_logged_in_from_other',
	'setcfg_ui_login_btn_label_for_logged_in_from_other',
	'setcfg_ui_login_err_msg_for_segment_mismatch',
	'setcfg_ui_ip_login_remind_text',
	'setcfg_ui_login_remind_text',
	'setcfg_ui_login_caption_label_for_local_content_eg',
	'setcfg_ui_login_caption_label_for_free_website',
	'setcfg_ui_login_link_text',
	'setcfg_ui_login_caption_label_for_term',
	'setcfg_ui_login_term_text'
    );
    $div = 'divUILoginPage';
	
	// need syn with settingok.php, fs_lang.php, editlang.php
	$styleArr = array('font-family','font-size','color');
	
	// need syn with settingok.php, fs_lang.php, editlang.php
	$applyStyle = array(
		'greeting',
		'user_name',
        'Password',
		'user_scratch',
		'sign_up_now',
        'anonymous',
		'anonymous_shared_secret',
		'login_form_reminder',
		'example',
		'free_website',
		'login_form_link',
		'term_condition',
		'login_form_term'
		);
		
	// list default value refer to style_pc.css
	$defaultStyleArr = array(
		'greeting' => array("Verdana","20pt","#FFFFFF", "textColor" => "black"),
		'user_name'=> array("Verdana","10pt","#000000"),
        'Password'=> array("Verdana","10pt","#000000"),
		'user_scratch'=> array("Verdana","10pt","#000000"),
		'sign_up_now'=> array("Verdana","10pt","red"),
        'anonymous'=> array("Verdana","10pt","#000000"),
		'anonymous_shared_secret'=> array("Verdana","10pt","#000000"),
		'login_form_reminder'=> array("Verdana","7pt","#A00040"),
		'example'=> array("italic","12pt","#0A008F"),
		'free_website'=> array("Verdana","10pt","#000000"),
		'login_form_link'=> array("italic","12pt","#0A008F"),
		'term_condition'=> array("Verdana","10pt","#000000"),
		'login_form_term'=> array("Verdana","10pt","#000000")
		);

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_login_heading'), $div, count($var) + count($applyStyle)+1+1);
    gen_sep();
	
	// custom background
	// get all the jpg file with name is *_stick.jpg 
	$bg_opt_arr = array();
	
	if ($handle = opendir('../authserv')) {
        while (false !== ($file = readdir($handle))) {
            if ( preg_match('/\w+_stick.jpg/', strtolower($file)) ) {
				// hard code
				if ( $file == "gray_stick.jpg"){
					// ignore, sicne it is special (default)
				}
				else
					$bg_opt_arr[] = $file;
            }
        }
        closedir($handle); 
    }
	
	$custom_bg_img = $settingobj->getKey( "custom_bg_img", "ui_customization");
	
	$input="";
	$input.='<select name="custom_bg_img">';
	
	$sel_cont="";		
	$isSelected = false;
	
	foreach($bg_opt_arr as $optVal){
		$tmp_sub = "";
		
		if ( $custom_bg_img == $optVal){
			$tmp_sub = 'selected="selected"';
			$isSelected = true;
		}
		$sel_cont.='<option value="'.$optVal.'" '.$tmp_sub.' >'.$optVal.'</option>';
	}
	
	if ($isSelected)
		$sel_cont='<option value="">gray_stick.jpg (default)</option>'.$sel_cont;
	else
		$sel_cont='<option value="" selected="selected">gray_stick.jpg (default)</option>'.$sel_cont;
		
	$input .= $sel_cont;
	$input.='</select>';	
	
	gen_invisible_line(get_cm_var('setcfg_ui_custom_background'), $input, $div.(count($var) + count($applyStyle)+1), "none");
	
	gen_invisible_sep($div."Sep".(count($var) + count($applyStyle)+1), "none");
	
	$countAdded=count($var);

	// 20090918 - Add checkbox control for related field display in login page
    // 20080430 - Add case for showing text area
    foreach ($var as $key => $value) {
		// 20100430 - Change labels for reminder, link and terms
		if ($value == 'free_website' || $value == 'term_condition' || $value == 'ip_login_form_reminder') {
		
			if ($value == 'ip_login_form_reminder')
				gen_invisible_textarea(get_cm_var($cmvar[$key]), get_textarea($value), $div.$key, "none", true);
			else
				gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
			
			if (in_array($value, $applyStyle)){
				$tmpCount = $countAdded+1;
				
				$rStr = $settingobj->getKey( $value, "ui_customization");
				
				if ($rStr != ""){
					$rArr = explode("|", $rStr);
				}
				else
					$rArr = array();
				
				gen_invisible_custom_Style($value,$styleArr,$defaultStyleArr[$value],$rArr, $div.$tmpCount,'none');
				$countAdded ++;
			}
			
		} 
		else if ($value == 'login_form_reminder' || $value == 'example' || $value == 'login_form_link' || $value == 'login_form_term') {
			$checkboxId = '';
			$fCheck = '';
			if ($value == 'login_form_reminder') {
				$checkboxId = 'disable_show_reminder';
				if (isset($disable_show_reminder) && $disable_show_reminder == 1) {
					$fCheck = 'checked';
				}
				gen_invisible_textarea(get_cm_var($cmvar[$key]), get_textarea($value), $div.$key, "none", false);
			} elseif ($value == 'example') {
				$checkboxId = 'disable_show_example';
				if (isset($disable_show_example) && $disable_show_example == 1) {
					$fCheck = 'checked';
				}
				gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
			} elseif ($value == 'login_form_link') {
				$checkboxId = 'disable_show_link';
				if (isset($disable_show_link) && $disable_show_link == 1) {
					$fCheck = 'checked';
				}
				gen_invisible_textarea(get_cm_var($cmvar[$key]), get_textarea($value), $div.$key, "none", false);
			} elseif ($value == 'login_form_term') {
				$checkboxId = 'disable_show_tc';
				if (isset($disable_show_tc) && $disable_show_tc == 1) {
					$fCheck = 'checked';
				}
				gen_invisible_textarea(get_cm_var($cmvar[$key]), get_textarea($value), $div.$key, "none", false);
			}
			
			if (in_array($value, $applyStyle)){
				$tmpCount = $countAdded+1;
				
				$rStr = $settingobj->getKey( $value, "ui_customization");
				
				if ($rStr != ""){
					$rArr = explode("|", $rStr);
				}
				else
					$rArr = array();
				
				gen_invisible_custom_Style($value,$styleArr,$defaultStyleArr[$value],$rArr, $div.$tmpCount,'none');
				$countAdded ++;
			}
			
			gen_invisible_checkbox($div.$key, 'none', $checkboxId, $fCheck);
			
			gen_invisible_sep($div."Sep".$key, "none");
		} else {
			// normal
			gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
			
			if (in_array($value, $applyStyle)){
				$tmpCount = $countAdded+1;
				
				$rStr = $settingobj->getKey( $value, "ui_customization");
				
				if ($rStr != ""){
					$rArr = explode("|", $rStr);
				}
				else
					$rArr = array();
				
				gen_invisible_custom_Style($value,$styleArr,$defaultStyleArr[$value],$rArr, $div.$tmpCount,'none');
				$countAdded ++;
			}
			
			gen_invisible_sep($div."Sep".$key, "none");
		}
	}

    //**************************************************************************************
    //  InfoBox
    //**************************************************************************************
    $var = array(
        'info_thank_you',
        'info_cart_btn',
        'info_logout_btn',
        'info_chgpwd_btn',
        'alert',
        'info_title',
        'info_access_min_remain',
		'anon_info_access_min_remain',
        'Unlimited',
        'Min',
        'Sec',
        'last_than_one_min',
        'info_please_login_again',
        'info_if_close',
        'info_logout',
        'info_in_browser',
		'info_first_loading_msg',
		'info_loading',
		'info_logged_in_from_other',
        //disconnect.php (under the InfoBox heading in UI)
        'Disconnected',
        'signed_success',
        //remaining of info.php - rarely seen - put aside to minimize confusion to users
        'info_expired',
        'info_please_logout'
    );
    $cmvar = array(
        'setcfg_ui_infobox_greeting_msg',
        'setcfg_ui_infobox_btn_label_for_get_air_time',
        'setcfg_ui_infobox_btn_label_for_logout',
        'setcfg_ui_infobox_btn_label_for_chgpwd',
        'setcfg_ui_infobox_msg_confirm_closing',
        'setcfg_ui_infobox_win_title',
        'setcfg_ui_infobox_caption_access_min_remaining',
		'setcfg_ui_infobox_anon_access_min_remaining',
        'setcfg_ui_infobox_describe_unlimited_access_timeleft',
        'setcfg_ui_infobox_describe_minute',
        'setcfg_ui_infobox_describe_second',
        'setcfg_ui_infobox_describe_less_than_one_minute',
        'setcfg_ui_infobox_msg_connection_idle_timeout',
        'setcfg_ui_infobox_hints_instant_keyword1',
        'setcfg_ui_infobox_hints_instant_keyword2',
        'setcfg_ui_infobox_hints_instant_keyword3',
		'setcfg_ui_infobox_first_load',
		'setcfg_ui_infobox_loading_box_waiting',
		'setcfg_ui_infobox_warn_msg_for_not_support',
        'setcfg_ui_infobox_caption_success_disconnection',
        'setcfg_ui_infobox_msg_success_disconnection',
        'setcfg_ui_infobox_err_msg1',
        'setcfg_ui_infobox_err_msg2'
    );
    $div = 'divUIInfoBox';

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_infobox_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
	gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, 'none');
        gen_invisible_sep($div."Sep".$key, 'none');
    }

    //**************************************************************************************
    //  logout.php, logoutscript.php
    //**************************************************************************************
    $var = array(
        'login_success', 'login_fail', 'back_btn'
    );
    $cmvar = array(
        'setcfg_ui_logout_msg_success_logout', 'setcfg_ui_logout_err_msg_invalid_username_password',
        'setcfg_ui_logout_btn_label_for_anonymous_mode'
    );
    $div = 'divUILogout';

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_logout_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, 'none');
    }

    //**************************************************************************************
    //  redirect.php
    //**************************************************************************************
    $var = array(
        'redirect_title', 'redirect_wait', 'redirect_msg'
    );
    $cmvar = array(
        'setcfg_ui_redir_win_title', 'setcfg_ui_redir_caption', 'setcfg_ui_redir_message'
    );
    $div = 'divUIRedir';

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_redir_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, 'none');
        gen_invisible_sep($div."Sep".$key, 'none');
    }

    //**************************************************************************************
    //  20081219 - Block page
    //**************************************************************************************
    $var = array(
	'block_ip_block_list',
	'block_client_blacklist',
	'block_web_filtering'
    );
    $cmvar = array(
	'setcfg_ui_block_ip_block_list',
	'setcfg_ui_block_client_blacklist',
	'setcfg_ui_block_web_filter'
    );
    $div = 'divUIBlock';

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_block_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, 'none');
        gen_invisible_sep($div."Sep".$key, 'none');
    }

    //**************************************************************************************
    //  chgpwd_form.php
    //**************************************************************************************
    $var = array(
        "chgpwd_form",
        "chgpwd_username",
        "chgpwd_oldpwd",
        "chgpwd_pwd1",
        "chgpwd_pwd2",
        "chgpwd_submit_btn",
        //fs_chgpwd.php
        "chgpwd_ok_header",
        "chgpwd_ok_link",
        "chgpwd_fail_header",
        "chgpwd_fail_link",
        "chgpwd_problem_id_empty",
        "chgpwd_problem_old_pwd_empty",
        "chgpwd_problem_new_pwd_empty",
        "chgpwd_problem_pwd_mismatch",
        "chgpwd_problem_id_not_exists",
        "chgpwd_problem_old_pwd_mismatch",
        "chgpwd_problem_access_right"
    );
    $cmvar = array(
        'setcfg_ui_chgpwd_caption',
        'setcfg_ui_chgpwd_label_username',
        'setcfg_ui_chgpwd_label_old_pwd',
        'setcfg_ui_chgpwd_label_new_pwd',
        'setcfg_ui_chgpwd_label_re_new_pwd',
        'setcfg_ui_chgpwd_btn_label_submit',
        'setcfg_ui_chgpwd_caption_success_pwd_chg',
        'setcfg_ui_chgpwd_link_label_success_pwd_chg',
        'setcfg_ui_chgpwd_caption_fail_pwd_chg',
        'setcfg_ui_chgpwd_link_label_fail_pwd_chg',
        'setcfg_ui_chgpwd_err_msg_empty_username',
        'setcfg_ui_chgpwd_err_msg_empty_old_pwd',
        'setcfg_ui_chgpwd_err_msg_empty_new_pwd',
        'setcfg_ui_chgpwd_err_msg_mismatched_pwd',
        'setcfg_ui_chgpwd_err_msg_id_not_exist',
        'setcfg_ui_chgpwd_err_msg_old_pwd_not_match',
        'setcfg_ui_chgpwd_err_msg_no_access_right'
    );
    $div = "divUIChgpwdForm";

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_chgpwd_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    //**************************************************************************************
    //  cart.php
    //**************************************************************************************
	// 20100524 - Add cart_anonymous, cart_free_access_not_support
	// 20090428 - Add radius_not_support
    $var = array(
        "cart_welcome",
        "cart_check_timeleft",
        "cart_check_txn",
        "cart_shopping_cart",
        "cart_desc",
        "cart_price",
        "cart_checkout",
        //cookies_warning.php
        "cookies_warning",
        //timeleft.php
        "timeleft_header",
		"cart_form_other_site",
		"cart_radius_not_support",
		'cart_anonymous',
		'cart_free_access_not_support'
    );
    $cmvar = array(
        'setcfg_ui_cart_greeting',
        'setcfg_ui_cart_link_label_for_timeleft',
        'setcfg_ui_cart_link_label_for_pre_cc_trans',
        'setcfg_ui_cart_title',
        'setcfg_ui_cart_col1_heading',
        'setcfg_ui_cart_col2_heading',
        'setcfg_ui_cart_btn_label_for_checkout',
        'setcfg_ui_cart_warn_msg_for_not_accept_cookies',
        'setcfg_ui_cart_timeleft_header',
		'setcfg_ui_cart_warn_msg_for_not_support',
		'setcfg_ui_cart_radius_not_support',
		'setcfg_ui_cart_anonymous',
		'setcfg_ui_cart_free_access_not_support'
    );
    $div = "divUICart";

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_cart_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    //**************************************************************************************
    //  paypal_history.php
    //**************************************************************************************
	// 20090428 - Add radius_not_support
    $var = array(
        "ppal_history_title",
        "ppal_history_col1",
        "ppal_history_col2",
        "ppal_history_col3",
        "ppal_history_col4",
        "ppal_history_col5",
        "ppal_history_status_empty",
        "ppal_history_status_completed",
        "ppal_history_status_pendingN",
        "ppal_history_status_pendingY",
        "ppal_history_status_refunded",
		"wpay_history_status_cancelled",
		"ppal_history_radius_not_support"
    );
    $cmvar = array(
        'setcfg_ui_cchistory_caption',
        'setcfg_ui_cchistory_col1',
        'setcfg_ui_cchistory_col2',
        'setcfg_ui_cchistory_col3',
        'setcfg_ui_cchistory_col4',
        'setcfg_ui_cchistory_col5',
        'setcfg_ui_cchistory_msg_uncompleted',
        'setcfg_ui_cchistory_msg_completed',
        'setcfg_ui_cchistory_msg_pending_no',
        'setcfg_ui_cchistory_msg_pending_yes',
        'setcfg_ui_cchistory_msg_refunded',
		'setcfg_ui_cchistory_msg_cancelled',
		'setcfg_ui_cchistory_radius_not_support'
    );
    $div = "divUIPaypalHistory";

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_cchistory_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    //**************************************************************************************
    //  extra information fields
    //**************************************************************************************
    $var = array(
        "extra_field_err_empty"
    );
    $cmvar = array(
        'setcfg_ui_extra_err_msg'
    );
    $div = "divUIExtra";

    $extra = array(
        "extra_field1", "extra_field2", "extra_field3", "extra_field4", "extra_field5",
        "extra_field6", "extra_field7", "extra_field8", "extra_field9", "extra_field10"
    );
    $extracb =  array(
        "extra01", "extra02", "extra03", "extra04", "extra05", "extra06", "extra07", "extra08", "extra09", "extra10"
    );
    $extracmvar =  array(
        'setcfg_ui_extra_field1', 'setcfg_ui_extra_field2', 'setcfg_ui_extra_field3', 'setcfg_ui_extra_field4', 'setcfg_ui_extra_field5',
        'setcfg_ui_extra_field6', 'setcfg_ui_extra_field7', 'setcfg_ui_extra_field8', 'setcfg_ui_extra_field9', 'setcfg_ui_extra_field10'
    );
    $extracbcmvar = array(
        'setcfg_ui_extra_field_req1', 'setcfg_ui_extra_field_req2', 'setcfg_ui_extra_field_req3', 'setcfg_ui_extra_field_req4', 'setcfg_ui_extra_field_req5',
        'setcfg_ui_extra_field_req6', 'setcfg_ui_extra_field_req7', 'setcfg_ui_extra_field_req8', 'setcfg_ui_extra_field_req9', 'setcfg_ui_extra_field_req10'
    );

    // store the number of items array $var
    $n = count($var);

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_extra_heading'), $div, $n+2*count($extra)+1);
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    $value=$settingobj->getKey( "Datasource_extra_field_table", "gateway");
    $input='<input class="longtextbox" type="text" name="Datasource_extra_field_table" value="'.$value.'"  onfocus="this.select()">';
    gen_invisible_line(get_cm_var('setcfg_ui_extra_table'), $input, "divUIExtra21", "none");
    gen_invisible_sep("divUIExtraSep21", "none");

    foreach($extra as $key => $value) {
        gen_invisible_line(get_cm_var($extracmvar[$key]), get_ln_extra($value, $extracb[$key]), $div.$n, "none");
        gen_invisible_sep($div."Sep".$n, "none");
        $n++;
        gen_invisible_line(get_cm_var($extracbcmvar[$key]), get_checkbox_extra($value, $extracb[$key]), $div.$n, "none");
        gen_invisible_sep($div."Sep".$n, "none");
        $n++;
    }

    
    //**************************************************************************************
    //  Request sign up extra information fields
    //**************************************************************************************
    $var = array(
        //ReqSignUp_form.php
        "ReqSignUp_title",
        "ReqSignUp_header",
        "ReqSignUp_submit_btn",
        //fs_ReqSignUp.php
        "ReqSignUp_ok_header",
        "ReqSignUp_ok_link",
        "ReqSignUp_fail_header",
        "ReqSignUp_fail_link",
        "ReqSignUp_problem_field_empty",
    );
    $cmvar = array(
        'setcfg_ui_RSU_title',
        'setcfg_ui_RSU_caption',
        'setcfg_ui_RSU_btn_label_submit_acc',
        'setcfg_ui_RSU_caption_success',
        'setcfg_ui_RSU_link_label_success',
        'setcfg_ui_RSU_cap_failed',
        'setcfg_ui_RSU_link_label_failed',
        'setcfg_ui_RSU_err_msg_empty_field',
    );
    $div = "divUIRSUForm";

    // store the number of items array $var
    $n = count($var);

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_RSU_heading'), $div, $n);
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    //**************************************************************************************
    //  signup_form.php
    //**************************************************************************************
	// 20100518 - Add session cookies disabled, signup_fa_title, signup_fa_submit
    // 20080418 - Add scratch mode invalid access label
    $var = array(
        "signup_form",
        "signup_username",
        "signup_pwd1",
        "signup_pwd2",
        "signup_submit_btn",
		'signup_fa_title',
		'signup_fa_submit',
        //fs_signup.php
        "signup_ok_header",
        "signup_ok_link",
        "signup_fail_header",
        "signup_fail_link",
        "signup_problem_id_empty",
        "signup_problem_pwd_empty",
        "signup_problem_pwd_mismatch",
        "signup_problem_id_duplicate",
        "signup_problem_field_empty",
		"signup_block_msg",
		"signup_problem_session_cookies_disabled"
    );
    $cmvar = array(
        'setcfg_ui_signup_caption',
        'setcfg_ui_signup_field_label_username',
        'setcfg_ui_signup_field_label_pwd',
        'setcfg_ui_signup_field_label_re_pwd',
        'setcfg_ui_signup_btn_label_submit_acc',
		'setcfg_ui_signup_fa_title',
		'setcfg_ui_signup_fa_submit',
        'setcfg_ui_signup_caption_success_acc_create',
        'setcfg_ui_signup_link_label_success_acc_create',
        'setcfg_ui_signup_cap_failed_acc_create',
        'setcfg_ui_signup_link_label_failed_acc_create',
        'setcfg_ui_signup_err_msg_empty_username',
        'setcfg_ui_signup_err_msg_empty_pwd',
        'setcfg_ui_signup_err_msg_mismatched_pwd',
        'setcfg_ui_signup_err_msg_duplicated_username',
        'setcfg_ui_signup_err_msg_empty_field',
		'setcfg_ui_signup_block_msg',
		'setcfg_ui_signup_session_cookies_disabled'
    );
    $div = "divUISignupForm";

    // store the number of items array $var
    $n = count($var);

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_signup_heading'), $div, $n);
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }
    
    //**************************************************************************************
    //  extra information fields for self-signup and Administrative create-user
    //**************************************************************************************
    $div = "divUIRSUExtra";

    $extra = array(
        "ReqSignUp_extra1", "ReqSignUp_extra2", "ReqSignUp_extra3", "ReqSignUp_extra4", "ReqSignUp_extra5",
        "ReqSignUp_extra6", "ReqSignUp_extra7", "ReqSignUp_extra8", "ReqSignUp_extra9", "ReqSignUp_extra10"
    );
    $extracb =  array(
        "ReqSignUp01", "ReqSignUp02", "ReqSignUp03", "ReqSignUp04", "ReqSignUp05", "ReqSignUp06", "ReqSignUp07", "ReqSignUp08",
        "ReqSignUp09", "ReqSignUp10"
    );
    $extracmvar =  array(
        'setcfg_ui_RSU_extra1', 'setcfg_ui_RSU_extra2', 'setcfg_ui_RSU_extra3', 'setcfg_ui_RSU_extra4', 'setcfg_ui_RSU_extra5',
        'setcfg_ui_RSU_extra6', 'setcfg_ui_RSU_extra7', 'setcfg_ui_RSU_extra8', 'setcfg_ui_RSU_extra9', 'setcfg_ui_RSU_extra10'
    );
    $extracbcmvar = array(
        'setcfg_ui_RSU_req_extra1', 'setcfg_ui_RSU_req_extra2', 'setcfg_ui_RSU_req_extra3', 'setcfg_ui_RSU_req_extra4', 'setcfg_ui_RSU_req_extra5',
        'setcfg_ui_RSU_req_extra6', 'setcfg_ui_RSU_req_extra7', 'setcfg_ui_RSU_req_extra8', 'setcfg_ui_RSU_req_extra9', 'setcfg_ui_RSU_req_extra10'
    );

    // store the number of items array $var
    $n =0;
    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_RSU_FIELD_heading'), $div, $n+2*count($extra));
    gen_sep();
    
    foreach($extra as $key => $value) {
        gen_invisible_line(get_cm_var($extracmvar[$key]), get_ln_extra($value, $extracb[$key]), $div.$n, "none");
        gen_invisible_sep($div."Sep".$n, "none");
        $n++;
        gen_invisible_line(get_cm_var($extracbcmvar[$key]), get_checkbox_extra($value, $extracb[$key]), $div.$n, "none");
        gen_invisible_sep($div."Sep".$n, "none");
        $n++;
    }
    
    
/*
    //**************************************************************************************
    //  print_form.php and print_auth.php
    //**************************************************************************************
    $var = array(
        'print_support',
        'print_ref_id',
        "print_page_count",
        "print_page_left",
        "print_username",
        "print_password",
        "print_error_token",
        "print_error_quota",
        "print_error_pwd"
    );
        $cmvar = array(
        'setcfg_ui_print_link',
        'setcfg_ui_print_refid',
        'setcfg_ui_print_page_count',
        'setcfg_ui_print_page_left',
        'setcfg_ui_print_username',
        'setcfg_ui_print_password',
        'setcfg_ui_print_err_msg_pwd',
        'setcfg_ui_print_err_msg_quota',
        'setcfg_ui_print_err_msg_token'
    );
    $div = "divUIPrintSupport";

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_print_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }
*/
	//**************************************************************************************
    //  iKeyRedirect_warning.php
    //**************************************************************************************

    $var = array(
        'ikeyRedirect_warn_access_port',
        'ikeyRedirect_warn_access_page'
    );
        $cmvar = array(
        'setcfg_ui_iKey_warn_msg_access_port',
        'setcfg_ui_iKey_warn_msg_access_page'
    );
    $div = "divUIInstantKeyword";

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_iKey_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    gen_sep();

}
// release the COM object
//$settingobj->Release();
$settingobj=null;

?>
