<?php

/****************************************************************************
**
** Warning : This file is used by FirstSpot API (fsapi.exe). Please do not modify.
**
*****************************************************************************/

include_once "..\\cfgmgr\\db_access.php";
include_once '..\\authserv\\common_functions.php';

class fsAPI{

	var $usr_table;
	var $usr_snTable;
	var $sni_typeTable;
	var $myDB;

	var $normal_user_table; // user table but not affect by radius
	var $user_log_table;
	var $ibmsg_table;
	var $msg_table;
	var $tmp_url_table;
	var $radius_tmp_table;
	//	List of social network user data type list
	var $socialDataType;
	var $lastErrorMsg		= "";
	
	private $matchKeyP		= "";
	private $matchKeyM		= "";

	function fsAPI() {
		$this->myDB			= new db();
		$this->usr_table	= $this->myDB->get_usr_table();
		$this->usr_snTable	= $this->myDB->get_usr_sn_table();
		$this->sni_typeTable= $this->myDB->get_snitype_table();

		$settingObj		= new COM("FSCONFIG.Cfgmgr") or die("fsAPI.php FSCONFIG.Cfgmgr Object cannot be created!");
		$isScenario2	= $settingObj->getKey('scenario2', 'gateway');
		$FOMode			= $settingObj->getKey('mode', 'FSFO');

		if($FOMode == 3)
			$this->enableLoadBalancing = 1;
		else
			$this->enableLoadBalancing = 0;

		$this->curr_siteID ="";
		if ($isScenario2 || $this->enableLoadBalancing){
			if ($this->enableLoadBalancing)
				$this->curr_siteID = $settingObj->getKey('MachineID', 'FSFO');
			else
				$this->curr_siteID = $settingObj->getKey('siteID', 'gateway');
		}

		$this->session_handling = $settingObj->getKey('session_handling', 'gateway');
		if($this->session_handling == 0){
			$this->matchKeyP = "\([0-9A-F]{2,2}(-[0-9A-F]{2,2}){5,5}\)$/";	// Passive Login Mac Key
			$this->matchKeyM = "_[0-9A-F]{2,2}(:[0-9A-F]{2,2}){5,5}$/";		// Multiple Login Mac Key
		}
		else{
			$this->matchKeyP = "\([0-9]{1,3}(.[0-9]{1,3}){3,3}\)$/";		// Passive Login IP Key(not in use)
			$this->matchKeyM = "_[0-9]{1,3}(.[0-9]{1,3}){3,3}$/";			// Multiple Login IP Key
		}

		$this->normal_user_table = $settingObj->getKey( "Datasource_Tablename", "gateway");
		$this->user_log_table = $settingObj->getKey( "Datasource_Log_Tablename", "gateway");
		$this->ibmsg_table = $settingObj->getKey( "Datasource_ibmsg_Tablename", "gateway");

		$this->msg_table = $settingObj->getKey( "Datasource_msg_Tablename", "gateway");
		$this->tmp_url_table = $settingObj->getKey( "datasource_tmp_URL_tablename", "gateway");
		$this->radius_tmp_table	= $settingObj->getKey( "Datasource_Tablename", "radius");
		$settingObj=null;

		$socialDataType	= array();
	}

	function getMLCUser($username, $isPL = false)
	{
		$childArray	= array();
		$rs			= NULL;
		$q			= "";
		$myMatchKey	= "";
		$muName		= "";

		if($username == "")
			return false;

		if($isPL)	// MPLogin User
			$q			= "SELECT name FROM ".$this->usr_table." WHERE name like '".$username."(%' and acctype = 6;";
		else		// Just MLogin User
			$q			= "SELECT name FROM ".$this->usr_table." WHERE name like '".$username."[_]_%' and acctype = 5;";

		$myMatchKey	= "/^".$username.$this->getSHMatchKey($isPL);

		//debugAlert($myMatchKey);
		//debugAlert($q);
		$rs = $this->myDB->query($q);

		if(!$rs)
			return false;

		while(odbc_fetch_row($rs))
		{
			$muName = odbc_result($rs, "name");
			//debugAlert($muName);
			// check if child user belongs to specific parent user
			// [uName]_[mac] = O , [uName]_[uName]_[mac] = X
			if(preg_match($myMatchKey, $muName)==1){
				array_push($childArray, $muName);
				//debugAlert($muName);
			}
		}

		return $childArray;
	}

	function queryLoginDuration($username="")
	{
		$fields = array();

		$cond1="";
		if (isset($username) && strcmp($username, "") != 0){
			$cond1= " AND name ='".$username."'";
		}

		$q="SELECT name, reserved2 FROM $this->usr_table WHERE reserved1 IS NOT NULL".$cond1." ORDER BY NAME";
		$result=$this->myDB->query($q);

		while (odbc_fetch_row($result)) 
		{
			$logintime=odbc_result($result,"reserved2"); // login time
			$name=odbc_result($result,"name");

			$fields[$name]['name'] = $name;
			$tmpCalDurStr = calculateDuration($logintime);
			list($timeDiff, $duration) = explode('|', $tmpCalDurStr);
			$fields[$name]['duration'] = $duration;
		}

		return $fields;
	}

	function queryCurrentDataTransfer($username="")
	{
		$fields = array();

		$myobj = new COM('FSAUTH.Authserv') or die('info.php FSAUTH.Authserv object cannot be created!');

		$cond1="";
		if (isset($username) && strcmp($username, "") != 0){
			$cond1= " AND name ='".$username."'";
		}

		$q="SELECT name, reserved1, bwcount, bwcountUL, bwcountSHA FROM $this->usr_table WHERE reserved1 IS NOT NULL".$cond1." ORDER BY NAME";

		$result=$this->myDB->query($q);

		while (odbc_fetch_row($result)) 
		{
			$name=odbc_result($result,"name");
			$macOrIp=odbc_result($result,"reserved1");
			$bwcountDL=odbc_result($result,"bwcount");
			$bwcountUL=odbc_result($result,"bwcountUL");
			$bwcountSHA=odbc_result($result,"bwcountSHA");

			$fields[$name]['name'] = $name;

			$bwUseDL = 0;
			$bwUseUL = 0;
			$bwUseSHA = 0;

			$bwUseAll=$myobj->QueryBW($macOrIp);
			list($bwUseDL, $bwUseUL,$bwUseSHA) = explode(',', $bwUseAll);

			if ($bwcountSHA == 1 || $bwcountSHA==2){
				$bwUseSHA = $bwUseSHA."KB";
				$fields[$name]['bwUseSHA'] = $bwUseSHA;

				$bwUseDL = $bwUseDL."KB";
				$bwUseUL = $bwUseUL."KB";

				$fields[$name]['bwUseDL'] = $bwUseDL;
				$fields[$name]['bwUseUL'] = $bwUseUL;
			}
			else{
				if ($bwcountDL == 1||$bwcountDL == 2){
					$bwUseDL = $bwUseDL."KB";
				}
				else{
					if ($bwcountDL == "" && $bwUseDL > 0){
						// using global setting
						$bwUseDL = $bwUseDL."KB";
					}
					else
						$bwUseDL = "NA";
				}

				if ($bwcountUL == 1||$bwcountUL == 2){
					$bwUseUL = $bwUseUL."KB";
				}
				else{
					if ($bwcountUL == "" && $bwUseUL > 0){
						// using global setting
						$bwUseUL = $bwUseUL."KB";
					}
					else
						$bwUseUL = "NA";
				}
				$fields[$name]['bwUseDL'] = $bwUseDL;
				$fields[$name]['bwUseUL'] = $bwUseUL;
			}
		}
		$myobj=null;

		return $fields;
	}


	// supportLiveUpdate = 0: not support live update, 1:support live update
	// return = 0: fail to update, 1: success, 2: user does not  exist, 3: fail to update by (user is online), 4: fail to update by (other site)
	function resetQuota($username="", $supportLiveUpdate=1)
	{
		$settingObj			= new COM("FSCONFIG.Cfgmgr") or die("dropinQuota.php FSCONFIG.Cfgmgr Object cannot be created!");
		$global_bwcountUL	= $settingObj->getKey( "bwcount_ul", "DataTransfer");
		$global_bwcountDL	= $settingObj->getKey( "bwcount_dl", "DataTransfer");
		$fs_status			= $settingObj->queryService();
		$settingObj			= null;
		$mpNames			= $username;
		$mac				= '';

		$revCond="";
		if ($supportLiveUpdate == 0)
			$revCond=" AND reserved1 IS NULL";

		$rs = $this->myDB->query("SELECT pwd as pw, reserved1, siteID, MACasUsr, acctype, bwcount, bwcountul, bwcountsha, macmap FROM $this->usr_table WHERE name = '$username';");

		if(odbc_fetch_row($rs))
		{
			$acctype	= intval(odbc_result($rs,"acctype"));
			$mac		= odbc_result($rs,"reserved1");
			$isMLogin	= ( $acctype == 3 || $acctype== 4 );
			$isPL		= ( odbc_result($rs,"macmap") == 2 );
			$strkey		= $isPL?'(':'_';

			// scan database if multiple login option is enabled
			if($isMLogin)
			{
				if($isPL)
					$tmpsql	= "SELECT name, reserved1 FROM $this->usr_table WHERE name like '".$username."(%' and acctype = 6;";
				else
					$tmpsql	= "SELECT name, reserved1 FROM $this->usr_table WHERE name like '".$username."[_]_%' and acctype = 5;";

				$rsm	= $this->myDB->query($tmpsql);
				while(odbc_fetch_row($rsm)){
					$childName	= odbc_result($rsm,"name");
					$tmpName	= $childName;

					// user is not multiple login child user
					if(!strstr($tmpName, $strkey))
						continue;

					// Handle username with multiple "_"
					while(strstr($tmpName, $strkey))
					{
						$tmpName = substr(strstr($tmpName, $strkey),1);
					}
					$tmpName = substr($childName, 0, strlen($childName)-strlen($tmpName)-1);

					// Compare usernames to define user is child user
					if(strcmp($username, $tmpName)==0)
					{
						// Do more check for user with login once option
						if($isPL){
							// Stop checking it and start the next if it is offline
							$tmpMac = odbc_result($rsm,"reserved1");

							// Record its name for updating DB
							$mpNames .= ' '.$childName;

							if($tmpMac==NULL || $tmpMac=='')
								continue;

							// Record mac/IP to reset counter in driver (live update)
							if($mac == '')
								$mac = $tmpMac;
							else
								$mac .= ' '.$tmpMac;
						}

						// Quit process if live update is disabled
						if($supportLiveUpdate == 0)
							return 3;
					}
				}
			}
			// End scanning Multiple Login Child User

			if(odbc_result($rs,"reserved1") != null && $supportLiveUpdate == 0)
				return 3;
			elseif ($this->enableLoadBalancing) {
				// 20100604 - User site ID is a Load Balancing Machine ID but not the same as the current machine
				if (strcasecmp(odbc_result($rs,'siteID'), 'Machine') > 0 && strcasecmp(odbc_result($rs,'siteID'), $this->curr_siteID) != 0)
					return 4;
			}
			elseif (strcasecmp(odbc_result($rs,"siteID"), $this->curr_siteID) != 0)	// other site
				return 4;
		}
		else			// user does not exist
			return 2;

		$mac		= explode(' ', $mac);
		$bwcountdl	= intval(odbc_result($rs,"bwcount"));
		$bwcountul	= intval(odbc_result($rs,"bwcountul"));
		$bwcounttl	= intval(odbc_result($rs,"bwcountsha"));

		// * data transfer allow sha or (dl or ul or both)
		// if Data Transfer (Total) is set, then reset all data transfer quota (dl, ul, sha)
		// if User is multiple passive login user, reset its child users
		$mpNames	= explode(' ', $mpNames);
		foreach($mpNames as $updateUN)
		{
			$sql		= "UPDATE $this->usr_table SET";
			$sqlCase	= "name='$updateUN' AND (siteID IS NULL OR siteID = '$this->curr_siteID')";
			if($bwcounttl == 2){
				$sql	=  "$sql accumbwul = NULL, accumbw = NULL, accumbwsha = 0 WHERE $sqlCase AND bwcountsha=2".$revCond;
				$this->myDB->query($sql);
			}
			else
			{
				// if Data Transfer (Upload ) is set or global upload quota is set, then reset all data transfer quota (ul, sha)
				if ($bwcountul == 2 || ($global_bwcountUL == "2" && $bwcountul = -1)){
					if($bwcountul == 0)
						$sql	.= " accumbwul = NULL,";
					else
						$sql	.= " accumbwul = 0,";
					$sqlCase	.= " AND bwcountul <> 1";
				}

				// if Data Transfer (Download ) is set or global download quota is set, then reset all data transfer quota (dl, sha)
				if ($bwcountdl == 2 || ($global_bwcountDL == "2" && $bwcountdl = -1)){
					if($bwcountdl == 0)
						$sql	.= " accumbw = NULL,";
					else
						$sql	.= " accumbw = 0,";
					$sqlCase	.= " AND bwcount <> 1";
				}

				$sql	= "$sql accumbwsha = NULL WHERE $sqlCase".$revCond;
				$this->myDB->query($sql);
			}
		}

		if ( $fs_status=="STARTED"){
			$myObj = new COM('FSAUTH.Authserv') or die('transaction.php FSAUTH.Authserv Object cannot be created!');
			if ($supportLiveUpdate == 1 && (isset($mac) && $mac!="") || (isset($isMLogin) && $isMLogin ))
			{
				if($isMLogin && !$isPL)
					$objresult = $myObj->UpdateBWcountM($username, 1);
				if($mac != false && $mac != NULL && $mac != '' && $mac[0]!=''){
					foreach($mac as $currentMac)
						$objresult = $myObj->UpdateBWcount($currentMac, 1);
				}
			}

			// passive login
			if (strcasecmp(odbc_result($rs,"MACasUsr") ,"y") == 0 && (odbc_result($rs,"pw") == null || odbc_result($rs,"pw") == ""))
				$this->PassiveLogin(1, $username); // update

			// multiple login user with login once
			if($isMLogin && $isPL)
			{
				foreach($mpNames as $updateUN)
				{
					if($updateUN == $username)
						continue;
					$this->PassiveLogin(1, $updateUN); // update
				}
			}
			$myObj=null;
		}
		return 1;
	}

	// for share secret use only 
	// return = 0: fail to update, 1: success, 5: fail to update by (group is using), 6: group does not exist
	function resetQuotaByShareSecret($groupname="")
	{
		$settingObj = new COM("FSCONFIG.Cfgmgr") or die("dropinQuota.php FSCONFIG.Cfgmgr Object cannot be created!");
		$sharedSecretTablename = $settingObj->getKey( "Datasource_Shared_Secret_Tablename", "gateway");
		$global_bwcountUL = $settingObj->getKey( "bwcount_ul", "DataTransfer");
		$global_bwcountDL = $settingObj->getKey( "bwcount_dl", "DataTransfer");
		$fs_status=$settingObj->queryService();
		$settingObj = null;

		$rs = $this->myDB->query("SELECT count(*) FROM $this->usr_table WHERE groupname ='$groupname' AND reserved1 IS NOT NULL;");

		// check is it using 
		if (odbc_fetch_row($rs)){
			if (odbc_result($rs,1) > 0){
				// group is using
				return 5;
			}
		}

		$rs = $this->myDB->query("SELECT groupname FROM $sharedSecretTablename WHERE groupname = '$groupname';");

		if(odbc_fetch_row($rs)){

		}
		else{
			// group does not exist
			return 6;
		}

		// * data transfer allow sha or (dl or ul or both)

		// if Data Transfer (Total) is set, then reset all data transfer quota (dl, ul, sha)
		$this->myDB->query("UPDATE $sharedSecretTablename SET accumbwul = NULL, accumbw = NULL, accumbwsha = NULL WHERE groupname='$groupname' AND bwcountsha=2");

		// 20090422 - Replace operator "not equal to" with "<>" type (DBF does not accept "!=")
		// if Data Transfer (Upload ) is set or global upload quota is set, then reset all data transfer quota (ul, sha)
		if ($global_bwcountUL == "2")
			$this->myDB->query("UPDATE $sharedSecretTablename SET accumbwul = NULL, accumbwsha = NULL  WHERE groupname = '$groupname' AND (bwcountul = 2 OR bwcountul IS NULL OR bwcountul = -1) AND (bwcountsha IS NULL OR (bwcountsha<>1 AND bwcountsha<>2))");
		else
			$this->myDB->query("UPDATE $sharedSecretTablename SET accumbwul = NULL, accumbwsha = NULL WHERE groupname = '$groupname' AND bwcountul = 2 AND (bwcountsha IS NULL OR (bwcountsha<>1 AND bwcountsha<>2))");

		// if Data Transfer (Download ) is set or global download quota is set, then reset all data transfer quota (dl, sha)
		if ($global_bwcountDL == "2")
			$this->myDB->query("UPDATE $sharedSecretTablename SET accumbw = NULL, accumbwsha = NULL WHERE groupname = '$groupname' AND (bwcount = 2 OR bwcount IS NULL OR bwcount = -1) AND (bwcountsha IS NULL OR (bwcountsha<>1 AND bwcountsha<>2))");
		else
			$this->myDB->query("UPDATE $sharedSecretTablename SET accumbw = NULL, accumbwsha = NULL WHERE groupname = '$groupname' AND bwcount = 2 AND (bwcountsha IS NULL OR (bwcountsha<>1 AND bwcountsha<>2))");

		return 1;
	}

	// userString foramt: name1,XXX2,XXX3
	// * already logged out user and not exist user also count in success
	/* return array (
		usr_forced_logout_count: number of forced logout user
		success_usr_str: forced logout user string
		fail_usr_str: failed user string
		result = 1: success, 2: Fail by FirstSpot is stopped
	)*/
	function disconnectUser($userString)
	{

		$fields = array();

		//debugAlert($userString);
		// Handle escape chars
		if (get_magic_quotes_gpc()) {
			if (isset($userString)) {
				$userString = stripslashes($userString);
			}
		}

		$arrUserToForcelogout = explode(',', $userString);

		$ForcelogoutString=""; // all site
		$current_ForcelogoutString=""; // current site
		$Other_Site_ForcelogoutString=""; // other site

		//print_r($arrUserToForcelogout);

		// sorting , for current site's user logout first, then another site
		foreach($arrUserToForcelogout as $val){
			$arr = explode('|', $val);
			if (isset($arr[1]) && $arr[1] !=""){
				if ($Other_Site_ForcelogoutString != ""){
					$Other_Site_ForcelogoutString.=",";
				}
				$Other_Site_ForcelogoutString.=$arr[0];
			}
			else{
				if ($current_ForcelogoutString != ""){
					$current_ForcelogoutString.=",";
				}
				$current_ForcelogoutString.=$arr[0];
			}
		}

		if($current_ForcelogoutString !=""){
			$ForcelogoutString.=$current_ForcelogoutString;
		}

		if($Other_Site_ForcelogoutString!=""){
			if($current_ForcelogoutString!=""){
				$ForcelogoutString.=",";
			}
			$ForcelogoutString.=$Other_Site_ForcelogoutString;
		}

		$settingObj = new COM("FSCONFIG.Cfgmgr") or die("fsAPI.php FSCONFIG.Cfgmgr Object cannot be created!");
		$fs_status=$settingObj->queryService();
		if ( $fs_status=="STARTED" ) { //can only disconnect user when FirstSpot is started
			// create COM object
			$myObj = new COM('FSAUTH.Authserv') or die('settingok.php FSAUTH.Authserv Object cannot be created!');
			$objrsult = $myObj->ForceLogout($ForcelogoutString);
			$myObj=null;

			// checking 
			$temp_chk_fields = array();
			$temp_chk_fields = $this->checkUserStatus($ForcelogoutString); 

			$fields['usr_forced_logout_count'] = $temp_chk_fields['offline_count'];
			$fields['success_usr_str'] = $temp_chk_fields['offline_usr_str'];
			$fields['fail_usr_str'] = $temp_chk_fields['online_usr_str'];
			$fields['result'] = 1;
		}
		else{
			$fields['result'] = 2;
			$fields['usr_forced_logout_count'] = 0;
		}
		$settingObj=null;

		return $fields;
	}

	// userString foramt: name1,XXX2,XXX3
	// * 28-08-09 modify delete passive login user sequence: (disconnect user > delete user > run QueryPassiveLogin > remove entry directly from driver)
	//  	Now not allow to delete passive login user when enable Load balancing and current state is Low priority
	/* return array (
		usr_forced_logout_count: number of forced logout user
		usr_deleted_count: number of deleted user
		success_usr_str: deleted user string
		fail_usr_str: failed user string
	)*/
	function deleteUser($userString)
	{
		$fields = array();

		// quit process if input is empty
		if($userString == NULL || $userString == '')
			return NULL;

		$settingObj = new COM("FSCONFIG.Cfgmgr") or die("deleteUser.php FSCONFIG.Cfgmgr Object cannot be created!");
		$myObj=new COM("FSAUTH.Authserv") or die("deleteUser.php FSAUTH.Authserv Object cannot be created!");

		$forcelogoutCount = 0;
		$arrUserToDelete=explode(",",$userString);
		$fs_status=$settingObj->queryService();
		$curr_priority = -1;
		if ($this->enableLoadBalancing == 1 && $fs_status=="STARTED"){
			// Get priority state
			$curr_priority = $settingObj->QueryPriority();
		}

		$temp_fields = array();
		$temp_fields = $this->checkUserStatus($userString);

		// disconnect online user first
		if($temp_fields['online_count'] >0){
			$temp_logout_fields = array();
			$temp_logout_fields = $this->disconnectUser($temp_fields['online_usr_str']);
			if ($temp_logout_fields['result'] == 1)
				$forcelogoutCount = $temp_logout_fields['usr_forced_logout_count'];
		}

		// delete users
		foreach ($arrUserToDelete as $value) {
			$q="SELECT pwd, MACasUsr, macmap, loginmac, acctype FROM $this->usr_table WHERE name = '$value';";
			$rs=$this->myDB->query($q);

			if(odbc_fetch_row($rs)){
				$acctype	= odbc_result($rs,"acctype");
				$loginmac	= odbc_result($rs,"loginmac");
				$macasUsr	= odbc_result($rs,"MACasUsr");
				$macmap		= odbc_result($rs,"macmap");
				$pw			= odbc_result($rs,"pwd");

				if (strcasecmp($macasUsr,"y") == 0 && $pw == ""){
					// is passive login

					// do not delete passive login user when current state is Low Priority
					if ($this->enableLoadBalancing == 1 && $curr_priority == 4 && $fs_status=="STARTED") // Low Priority
						continue;

					// prevent special case of some user which using other site, but that site can't force logout immediately
					$delQuery="DELETE FROM $this->usr_table WHERE name='$value' and (siteID is null or siteID = '$this->curr_siteID') and reserved1 is null;";

					$delResult=$this->myDB->query($delQuery);

					if ( $fs_status=="STARTED" ) { //only run the following lines when FirstSpot is started

						$macOrIp=0;
						if ($this->session_handling == 0){ // check MAC
							if ($this->check_mac($value) == true){
								$this->PassiveLogin(2, $value); // remove
								$macOrIp = mac_address_translate($value);
								$myObj->RemoveDrvEntry($macOrIp);
							}
							else if ($macmap == 2 && $loginmac > 0 && $loginmac != '' && $loginmac != null){ // passive login (login once)
								$this->PassiveLogin(2, $value); // remove

								// double check is it exist normal passive login with the same mac
								$isExistNormalPassive = false;

								$macOrIpStr = "";
								$macOrIpStr = make_mac_name($loginmac);
								$rs = $this->myDB->query("SELECT count(*) FROM $this->usr_table WHERE name ='$macOrIpStr' AND pwd IS NULL AND (MACasUsr = 'y' OR MACasUsr = 'Y');");
								if (odbc_fetch_row($rs)){
									if (odbc_result($rs,1) > 0){
										// is exist
										$isExistNormalPassive = true;
									}
								}
								if (!$isExistNormalPassive)
									$myObj->RemoveDrvEntry($loginmac);
							}
						}
						else{ // check IP
							if ($this->check_ip($value) == true){
								$this->PassiveLogin(2, $value); // remove
								// since the bytes of this ip is inverted, we need to reformat it
								$ip = explode(".",$value);
								$IP_str=$ip[3].".".$ip[2].".".$ip[1].".".$ip[0];
								// Because PHP's integer type is signed, and many IP addresses will result in negative integers, you need to use the "%u" formatter of sprintf() or printf() to get the string representation of the unsigned IP address
								$macOrIp = sprintf("%u", ip2long($IP_str));
								$myObj->RemoveDrvEntry($macOrIp);
							}

						}

					}
				}
				else{
					// other user
					if(($acctype == 3 || $acctype == 4) && $macmap == 2){
						// user is multiple login once
						$this->deleteUser(join(',', $this->getMLCUser($value, true)));
					}

					// prevent special case of some user which using other site, but that site can't force logout immediately
					$delQuery="DELETE FROM $this->usr_table WHERE name='$value' and (siteID is null or siteID = '$this->curr_siteID') and reserved1 is null;";

					$delResult=$this->myDB->query($delQuery);
				}
			}
		}

		$myObj=null;
		$settingObj=null;

		// checking 
		$temp_chk_fields = array();
		$temp_chk_fields = $this->checkUserStatus($userString, 1);

		$fields['usr_forced_logout_count'] = $forcelogoutCount;
		$fields['usr_deleted_count'] = $temp_chk_fields['not_exist_count'];
		$fields['success_usr_str'] = $temp_chk_fields['not_exist_str'];
		$temp_char="";
		if ($temp_chk_fields['online_count'] > 0 && $temp_chk_fields['offline_count'] >0)
			$temp_char=",";

		$fields['fail_usr_str'] = $temp_chk_fields['online_usr_str'].$temp_char.$temp_chk_fields['offline_usr_str'];

		return $fields;
	}

	// 20150619 Return Null if $userString is empty and get multiple login child user with passive login option or not
	function checkUserStatus($userString, $option=0)
	{

		$fields = array();

		if($userString == NULL || $userString == "")
			return NULL;

		$arrUser=explode(",",$userString);

		if ($option == 1)	// all user
			$query="SELECT name, reserved1, acctype, macmap FROM $this->usr_table order by name";
		else				// user is online or multiple login user
			$query="SELECT name, reserved1, acctype, macmap FROM $this->usr_table WHERE reserved1 IS NOT NULL OR acctype = 3 OR acctype = 4 OR acctype = 6 order by name";
//			Multiple login once user can be offline, below SQL is not enough
//			$query="SELECT name, reserved1, acctype, macmap FROM $this->usr_table WHERE reserved1 IS NOT NULL OR acctype = 3 OR acctype = 4";

		$result=$this->myDB->query($query);

		$allusers=array();
		while( odbc_fetch_row($result) ) {
			$name		=odbc_result($result,"name");
			$allusers[$name]['name']		=$name;
			$allusers[$name]['reserved1']	=odbc_result($result,"reserved1");
			$allusers[$name]['acctype']		=odbc_result($result,"acctype");
			$allusers[$name]['macmap']		=odbc_result($result,"macmap");
		}

		$online_count	=0;
		$offline_count	=0;
		$not_exist_count=0;
		$online_usr_str	="";
		$offline_usr_str="";
		$not_exist_str	="";
		$myMatchKey		="";

		foreach( $arrUser as $name )
		{
			if( !isset($allusers[$name]['name']) || strcasecmp($allusers[$name]['name'], $name) != 0)
				continue;
			// user has multiple login option
			if (isset($allusers[$name]['acctype']) && ($allusers[$name]['acctype'] == 3 || $allusers[$name]['acctype'] == 4)){
				$childAT = 5;
				if(isset($allusers[$name]['macmap']) && $allusers[$name]['macmap']==2)
					$childAT = 6;

				$myMatchKey = "/^".$name.$this->getSHMatchKey($childAT == 6);

				//debugAlert($myMatchKey);
				foreach( $allusers as $k => $arr )
				{
					// 20150619 - Add process for Multiple Login Once User
					if (isset($allusers[$k]['acctype']) && $allusers[$k]['acctype'] == $childAT){
						// user is online multiple login user
						if (isset($allusers[$k]['reserved1']) && $allusers[$k]['reserved1'] != ""
								&& $allusers[$k]['reserved1'] !=null && $allusers[$k]['reserved1'] >0
								&& preg_match($myMatchKey, $k)==1){
							if ($online_count >0)
								$online_usr_str.=",";
							$online_usr_str.=$allusers[$k]['name'];
							$online_count++;
							// remove user who are being found
							unset($allusers[$k]);
						}
						// user is offline multiple login once user
						else if($childAT == 6 && preg_match($myMatchKey, $k)==1){
							if ($offline_count >0)
								$offline_usr_str.=",";
							$offline_usr_str.=$allusers[$k]['name'];
							$offline_count++;
							// remove user who are being found
							unset($allusers[$k]);
						}
					}
				}
			}
			else if (isset($allusers[$name]['reserved1']) && $allusers[$name]['reserved1'] != "" && $allusers[$name]['reserved1'] !=null && $allusers[$name]['reserved1'] >0){
				// user is online
				if ($online_count >0)
					$online_usr_str.=",";
				$online_usr_str.=$name;
				$online_count++;
				// remove user who are being found
				unset($allusers[$name]);
			}
			else{
				// user is offline 
				if ($offline_count >0)
					$offline_usr_str.=",";
				$offline_usr_str.=$name;
				$offline_count++;
				// remove user who are being found
				unset($allusers[$name]);
			}
		}

		$fields['online_count']= $online_count;
		$fields['offline_count']= $offline_count;
		$fields['not_exist_count']= $not_exist_count;
		$fields['online_usr_str']= $online_usr_str;
		$fields['offline_usr_str']= $offline_usr_str;
		$fields['not_exist_str']= $not_exist_str;

		return $fields;
	}

	function __destruct(){
		if (isset($this->myDB)) {
			$this->myDB->close();
			unset($this->myDB);
		}
	}

	// 20100423 - Add bFromPlan
	// 20090708 - Add bFieldNumeric
	// fileds[key]: key must be in lower case
	// flagResetBwCount = 1: reset data transfer quota of (reset corresponding data transfer by $fields<bwcountXX>) (mainly for shopping cart use)
	// flagIntegrityCheck = 1: have data integrity check in update statement
	// return = 0: fail to update, 1: success, 2: fail by (user does not exist), 3: fail by (other site), 4: success (with info)
	// * during live update: timeleft not allow updated value less than orginal one, (except unlimit to limited value)
	// *									data transfer quota only allow update when that counter = 2, ([Yes and disable...] option)
	// * No validation checking on update data transfer counter (eg. behavior: only allow using total or (ul, dl or both) )
	// 26-01-2010 add * during expiry month (emonth, eyear) is set, edate and eminutes will not be updated and set to NULL value (behavior: emonth, eyear is super seed edate and emintes)
	function update_usr_attributes($username, $fields, $bFieldNumeric, $flagResetBwCount=0, $flagIntegrityCheck=1, $bFromPlan=0)
	{
		$updateChild	= false;
		$childcase		= '';
		$userfields		=array();

		$q				= "SELECT * FROM ".$this->usr_table." WHERE name='".$username."'";
		$result			= $this->myDB->query($q);

		if (odbc_fetch_row($result)) {
			// 20071204 - Round all numeric fields
			for ($i = 1; $i <= odbc_num_fields($result); $i++) {
				if ((strtolower(odbc_field_type($result, $i)) == "numeric" || strtolower(odbc_field_type($result, $i)) == "integer") && (odbc_result($result, $i) != NULL || strlen(odbc_result($result, $i)) > 0))
					$userfields[strtolower(odbc_field_name($result, $i))] = round(odbc_result($result, $i));
				else
					$userfields[strtolower(odbc_field_name($result, $i))] = odbc_result($result, $i);
			}
		}
		else			// user does not exist
			return 2;

		// init
		$newBwCountDl = "-2";
		$newBwCountUl = "-2";
		$newBwCountShare = "-2";

		// for checking the user is online
		$userMac = odbc_result($result, "reserved1");
		if ($userMac == NULL) {
			$userMac = '';
		}


		$userSiteID = odbc_result($result, "siteID");
		if ($userSiteID == NULL) {
			$userSiteID = '';
		}

		//\\ Delete Child if function disabled
		if($userfields["macmap"] == 2 && ($userfields["acctype"] == 3 || $userfields["acctype"] == 4)){
			if($fields["macmap"] != 2 || ( $fields["acctype"] != 3 && $fields["acctype"] != 4 ))
				$this->deleteUser(join(',', $this->getMLCUser($username, true)));
			else{	//\\ 20121119 >>> 000 - Sql for update Child user of MPLUser
				$updateChild	= true;
				$childList		= $this->getMLCUser($username, true);
				$childUpdateCol	= array("sdate", "bwquota", "bwquotaul", "bwquotasha", "bwcount", "bwcountul", "bwcountsha",
						"btul", "btdl", "status", "startmod", "edate", "pagenum", "acl", "roption", "rsdate", "redate", "weeksch",
						"resetopt", "ipmap", "siteID", "iBMsg_glo", "iBMsg_per", "loginseg", "emonth", "eyear", "portflt");
				$childField		= array();
				$childIsNum		= array();
				$childcase		= 'where name=\''.join('\' or name=\'', $childList).'\'';
			}
		}


		// interpret the update field
		$c = 0;
		foreach($fields as $k => $v){
			if ($k == "pagenum"){
				if ( (odbc_result($result, $k) == null || odbc_result($result, $k) == "") && (strlen($fields[$k]) > 0 || $fields[$k] != null) )
					$fields[$k] = NULL;
			}
			else if ($k == "bwquota" || $k == "bwquotaul" || $k == "bwquotasha"){
				if (strlen($fields[$k]) > 0 || $fields[$k] != NULL) {
					$fields[$k] = round($fields[$k]);
				}
				else {
					$fields[$k] = NULL;
				}
			}
			else if ($k == "bwcount"){
				$newBwCountDl = round($fields["bwcount"]);
				if ($v == -1)
					$fields["bwcount"] = "";
			}
			else if ($k == "bwcountul"){
				$newBwCountUl = round($fields["bwcountul"]);
				if ($v == -1)
					$fields["bwcountul"] = "";
			}
			else if ($k == "bwcountsha"){
				$newBwCountShare = round($fields["bwcountsha"]);
				if ($v == -1)
					$fields["bwcountsha"] = "";
			}
			else{
				// others
			}

			if ($k == "timeleft" && $userMac != ""){		// checking part
				// user is online
				// not allow update value less than orginal one, (except unlimit to limit value)
				if (!($fields[$k] == NULL || ($fields[$k] > 0 && (odbc_result($result, $k) == null || odbc_result($result, $k) == "" || $fields[$k]  > odbc_result($result, $k) ))))
					$fields[$k] = "unused";
			}
			if(isset($childUpdateCol)){
				foreach($childUpdateCol as $x){
					if($k == $childUpdateCol[$x]){
						$childField[$k] = $field[$k];
						$childIsNum[$k] = $bFieldNumeric[$k];
					}
				}
			}
		}


		// checking part 2 (will affect another field)
		if (array_key_exists("emonth", $fields) && $fields["emonth"] > 0 && array_key_exists("eyear", $fields) && $fields["eyear"] > 0){
			// ignore edate and eminutes, and set to NULL value

			$fields["edate"] = "";
			$fields["eminutes"] = "";
		}


		$userBwCountDl		= round(odbc_result($result, "bwcount"));
		$userBwCountUl		= round(odbc_result($result, "bwcountul"));
		$userBwCountShare	= round(odbc_result($result, "bwcountsha"));
		$userBwQuotaDl		= round(odbc_result($result, "bwquota"));
		$userBwQuotaUl		= round(odbc_result($result, "bwquotaul"));
		$userBwQuotaShare	= round(odbc_result($result, "bwquotasha"));


		if ($userMac != "") {

			// user is online
			if (strcasecmp($userSiteID, $this->curr_siteID) != 0)			// other site
				return 3;

			// check updated counter == orginal counter == 2 ([Yes and disable...] option)
			if (($newBwCountDl !="-2" && $newBwCountDl != 2) || $userBwCountDl != 2)
				$fields["bwquota"] = "unused";

			if (($newBwCountUl !="-2" && $newBwCountUl != 2) || $userBwCountUl != 2)
				$fields["bwquotaul"] = "unused";

			if (($newBwCountShare !="-2" && $newBwCountShare != 2) || $userBwCountShare != 2)
				$fields["bwquotasha"] = "unused";
		}
		else{
			// * -1 or ""(empty string): using global setting, 0: disabled, 1: enabled, 2: enabled plus enforce 

			// if (updated data) not using [Yes and disable...] option, set quota to null value
			if ($newBwCountDl != "-2" && $newBwCountDl != 2)
				$fields["bwquota"] = "";
			// do not update quota when counter !=2
			else if (array_key_exists("bwquota", $fields) && strlen($fields["bwquota"]) > 0 && $fields["bwquota"] != NULL && $newBwCountDl == "-2" && $userBwCountDl != 2)
				$fields["bwquota"] = "unused";

			if ($newBwCountUl != "-2" && $newBwCountUl != 2)
				$fields["bwquotaul"] = "";
			// do not update quota when counter !=2
			else if (array_key_exists("bwquotaul", $fields) && strlen($fields["bwquotaul"]) > 0 && $fields["bwquotaul"] != NULL && $newBwCountUl == "-2" && $userBwCountUl != 2)
				$fields["bwquotaul"] = "unused";

			if ($newBwCountShare != "-2" && $newBwCountShare != 2)
				$fields["bwquotasha"] = "";
			// do not update quota when counter !=2
			else if (array_key_exists("bwquotasha", $fields) && strlen($fields["bwquotasha"]) > 0 && $fields["bwquotasha"] != NULL && $newBwCountShare == "-2" && $userBwCountShare != 2)
				$fields["bwquotasha"] = "unused";

			// set accumulative usage to null value, when it (updated data) is disabled (set [No] option) 
			if ($newBwCountDl != "-2" && $newBwCountDl == 0 )
				$fields["accumbw"] = "";

			if ($newBwCountUl != "-2" && $newBwCountUl == 0 )
				$fields["accumbwul"] = "";

			if ($newBwCountShare != "-2" && $newBwCountShare == 0 )
				$fields["accumbwsha"] = "";
		}

		$fname_online_exclude = array ("pname", "accumbw", "bwcount", "accumbwul", "bwcountul", "accumbwsha", "bwcountsha", "resetopt", "ipmap", "portflt");
		$fname_offline_exclude = array("pname");

		$field_update = array();

		$file_exclude = array();

		if ($userMac!="")			// user is online
			$file_exclude = $fname_online_exclude;
		else
			$file_exclude = $fname_offline_exclude;

		foreach ($file_exclude as $fname){
			$fields[$fname] = "unused";
		}


		foreach ($fields as $key => $value) {
			if (strcmp("$value", "unused") != 0) {
				if(preg_match('/^(\d{1,2}-){1,2}\d{4} \d{1,2}:\d{1,2}$/', $value)){ //\\ - 20120824 - edate format error fixing ( with regexp )
					list($edate,$etime) = explode(" ", $value);
					$value = (String)datetime_from_php($edate,$etime);
				}
				$field_update[$key] = $value;
				// 20121119 Copy data for update child user of Multiple Login Once user
				if($updateChild && isset($childUpdateCol)){
					foreach($childUpdateCol as $x => $col){
						if($key == $col){
							$childField[$key] = $value;
							$childIsNum[$key] = $bFieldNumeric[$key];
						}
					}
				}
			}
		}

		if ($flagIntegrityCheck == 1){
			//generate SQL clause for data integrity check
			$i = 0;
			$temp = array();
			foreach($userfields as $fname => $fvalue) {
				if($fname != "signup01" && $fname != "signup02" && $fname != "signup03" && $fname != "signup04" &&
				$fname != "signup05" && $fname != "signup06" && $fname != "signup07" && $fname != "signup08" &&
				$fname != "signup09" && $fname != "signup10") {
					if (strlen($fvalue) > 0 || $fvalue != NULL) {
						if (isset ($bFieldNumeric[$fname]) && $bFieldNumeric[$fname])
							$temp[$i] = "$fname = ".round($fvalue);
						else if (isset ($bFieldNumeric[$fname]) && !$bFieldNumeric[$fname])
							$temp[$i] = "$fname = '$fvalue'";
						// prevent not set in bFieldNumeric (field get from db)
						else if(is_numeric($fvalue) && $fname != "name" && $fname != "pwd" && $fname != "reserved1" &&
						$fname != "edate" && $fname != "sdate" && $fname != "bwrmethod" && $fname != "anonymous" &&
						$fname != "macasusr" && $fname != "groupname" && $fname != "reqsignup" && $fname != "acl" &&
						$fname != "signupmac" && $fname != "rsdate" && $fname != "redate" && $fname != "loginmac" &&
						$fname != "portflt" && $fname != "faregtime" && $fname != "used" && $fname != "login_cpw" &&
						$fname != "emailVer" && $fname != "socialname" && $fname != "socialdesc")
							$temp[$i] = "$fname = ".round($fvalue);
						else
							$temp[$i] = "$fname = '$fvalue'";
					}
					else{
						if ($fname == "rsdate" || $fname == "redate")
							$temp[$i] = "($fname IS NULL OR $fname = '')"; // is null or empty string
						else
							$temp[$i] = "$fname IS NULL";
					}
					$i++;
				}
			}
			$clause = implode(" AND ", $temp);
		}
		else
			$clause = "name = '$username'";


		if (count($field_update) >0){

			// set quota to null value when counter != 2
			if ((array_key_exists("bwcount", $field_update) && $field_update["bwcount"] != 2) || (!array_key_exists("bwcount", $field_update) && $userBwCountDl != 2))
				$field_update["bwquota"] = "";
			if ((array_key_exists("bwcountul", $field_update) && $field_update["bwcountul"] != 2) || (!array_key_exists("bwcountul", $field_update) && $userBwCountUl != 2))
				$field_update["bwquotaul"] = "";
			if ((array_key_exists("bwcountsha", $field_update) && $field_update["bwcountsha"] != 2) || (!array_key_exists("bwcountsha", $field_update) && $userBwCountShare != 2))
				$field_update["bwquotasha"] = "";

			$this->myDB->update($this->usr_table, $field_update, "WHERE $clause", $bFieldNumeric);
			if($updateChild){
//				$this->myDB->update($this->usr_table, $childField, $childcase, $childIsNum);
				foreach($childList as $childName){
					$this->update_usr_attributes($childName, $childField, $childIsNum);
				}
			}
		}
		else
			return 0;

		// ----------Mainly for Shopping Cart Behavior-------
		// Save the unchanged quota value to reserved field for later restorage during online udpate
		if ($userMac != "") {
			if ($newBwCountDl != "-2" && $newBwCountDl != 2 && $userBwCountDl == 2){
				$this->myDB->query("UPDATE $this->usr_table SET reserved13 = $userBwQuotaDl WHERE name = '$username' AND bwcount = 2");
			}
			if ($newBwCountUl != "-2" && $newBwCountUl != 2 && $userBwCountUl == 2){
				$this->myDB->query("UPDATE $this->usr_table SET reserved14 = $userBwQuotaUl WHERE name = '$username' AND bwcountul = 2");
			}
			if ($newBwCountShare != "-2" && $newBwCountShare != 2 && $userBwCountShare == 2){
				$this->myDB->query("UPDATE $this->usr_table SET reserved17 = $userBwQuotaShare WHERE name = '$username' AND bwcountsha = 2");
			}
		}

		// reset quota with corresponding updated counter
		if ($flagResetBwCount == "1") {
			if ($newBwCountDl == 2)
				$this->myDB->query("UPDATE $this->usr_table SET accumbw = 0 WHERE name = '$username'");
			if ($newBwCountUl == 2)
				$this->myDB->query("UPDATE $this->usr_table SET accumbwul = 0 WHERE name = '$username'");
			if ($newBwCountShare == 2)
				$this->myDB->query("UPDATE $this->usr_table SET accumbwsha = 0 WHERE name = '$username'");
		}

		// ----------END-------

		// check FirstSpot status
		$settingObj	= new COM("FSCONFIG.Cfgmgr") or die("editUser.php FSCONFIG.Cfgmgr Object cannot be created!");
		$fs_status	= $settingObj->queryService();
		$settingObj	= null;


		if ($fs_status == "STARTED")
			$this->live_update($username, $flagResetBwCount, $bFromPlan, false);

		//query passive login (when change to [passive login] type or orginal is [passive login] type)
		if ((strcasecmp($userfields['macasusr'],"y") == 0 || (isset($field_update['macasusr']) && strcasecmp($field_update['macasusr'],"y") == 0)) && 
				(( $userfields['pwd']=="") || array_key_exists("pwd",$field_update) && $field_update['pwd']=="")){

			if ($fs_status=="STARTED") {


				if (strcasecmp($userfields['macasusr'],"y") == 0 && $userfields['pwd']==""){

					// orginal is [passive login] type

					// remain passive login type or change to [passive login] type
					if ((!array_key_exists("macasusr",$field_update) || strcasecmp($userfields['macasusr'],"y") == 0) && (!array_key_exists("pwd",$field_update) || $field_update['pwd']==""))
						$this->PassiveLogin(1, $username); // add or update
					else
						$this->PassiveLogin(2, $username); // remove
				}
				else			// new change to [passive login] type
					$this->PassiveLogin(1, $username); // add / update

			}

		}

		return 1;
	}

	// 20100423 - Add bFromPlan
	// 26-01-2010 add expiry month, which is super seed edate, so that it will ignore live update edate field when expiry month (emonth, eyear) is set
	// return = 0: fail, 1: success, 2: fail by (FirstSpot is stopped), 3: fail by (other site)
	function live_update($username, $flagResetBwCount, $bFromPlan, $onlineMLogin, $editEdate=0)
	{

		$updatedRet = 0;

		$q="SELECT reserved1, timeleft, reserved12, bwcount, bwcountul, bwcountsha, bwquota, bwquotaul, bwquotasha, accumbw, accumbwul, accumbwsha, btul, btdl, resetopt, edate, siteID, emonth, eyear FROM $this->usr_table WHERE name = '$username'";

		$result=$this->myDB->query($q);
		if(!odbc_fetch_row($result))
			return 0;

		$mac		= odbc_result($result, "reserved1");
		$siteID		= odbc_result($result, "siteID");
		$resetopt	= ( odbc_result($result, "resetopt")==""? 0 : round(odbc_result($result, "resetopt")) );

		// 20071207 - Add edate, adjust tleft output value
		$tleft = (odbc_result($result, "timeleft") == ""? "" : round(odbc_result($result, "timeleft")));
		if ($tleft != "")
			$tleft -= (odbc_result($result, "reserved12") == ""? 0 : round(odbc_result($result, "reserved12")));
		$edate = odbc_result($result, "edate") == NULL? "" : odbc_result($result, "edate");

		$emonth = (odbc_result($result, "emonth") == ""? "" : round(odbc_result($result, "emonth")));
		$eyear = (odbc_result($result, "eyear") == ""? "" : round(odbc_result($result, "eyear")));

		$expire_month_u_time = -1;
		$expire_month = "";

		// interpret expiry month
		if ($emonth != "" && $emonth > 0 && $eyear != "" && $eyear >0 ){
			$expire_month_u_time = interpret_expire_month($emonth, $eyear);
			if ($expire_month_u_time > 0)
				$expire_month = date("D M d H:i:s Y", $expire_month_u_time);
		}

		// 20071213 - Round other fields also
		// 20071212 - Bug fix for bwaccum variables
		// 20071127 - Add bandwidth quota sharing related checking
		$bwcount_ul		= (odbc_result($result, "bwcountul")	== ""? 0 : round(odbc_result($result, "bwcountul")));
		$bwcount_dl		= (odbc_result($result, "bwcount")		== ""? 0 : round(odbc_result($result, "bwcount")));
		$bwcount_share	= (odbc_result($result, "bwcountsha")	== ""? 0 : round(odbc_result($result, "bwcountsha")));
		$bwquota_ul		= (odbc_result($result, "bwquotaul")	== ""? 0 : round(odbc_result($result, "bwquotaul")));
		$bwquota_dl		= (odbc_result($result, "bwquota")		== ""? 0 : round(odbc_result($result, "bwquota")));
		$bwquota_share	= (odbc_result($result, "bwquotasha")	== ""? 0 : round(odbc_result($result, "bwquotasha")));
		$bwaccum_ul		= (odbc_result($result, "accumbwul")	== ""? 0 : round(odbc_result($result, "accumbwul")));
		$bwaccum_dl		= (odbc_result($result, "accumbw")		== ""? 0 : round(odbc_result($result, "accumbw")));
		$bwaccum_share	= (odbc_result($result, "accumbwsha")	== ""? 0 : round(odbc_result($result, "accumbwsha")));
		$bwquota_ul		-= $bwaccum_ul;
		$bwquota_dl		-= $bwaccum_dl;
		$bwquota_share	-= $bwaccum_share;

		$throttle_ul	= ( odbc_result($result, "btul")==""? -1 : round(odbc_result($result, "btul")) );
		$throttle_dl	= ( odbc_result($result, "btdl")==""? -1 : round(odbc_result($result, "btdl")) );

		$settingObj		= new COM('FSCONFIG.Cfgmgr') or die('transaction.php FSCONFIG.Cfgmgr Object cannot be created!');
		$fs_status		= $settingObj->queryService();
		$settingObj		= null;

		// 20070925 - Modify condition and input parameters to perform data transfer quota update

		if($mac != "" || $onlineMLogin) {

			if ($fs_status=="STARTED"){

				if(strcasecmp($siteID, $this->curr_siteID) != 0)		// other site client
					$updatedRet = 3;
				else{
					// 20071207 - Obtain config setting object here
					$myObj = new COM('FSAUTH.Authserv') or die('transaction.php FSAUTH.Authserv Object cannot be created!');

					// 20071127 - Add checking of bwcount_share
					// 20071004 - Remove quota conditions
					// update data transfer quota with reset current usage or not

					if ($bwcount_ul == 2 || $bwcount_dl == 2 || $bwcount_share == 2) {

						if(!$onlineMLogin)
							$objresult = $myObj->UpdateBWcount($mac, $flagResetBwCount);
						else
							$objresult = $myObj->UpdateBWcountM($username, $flagResetBwCount);
						$updatedRet = 1;
					}


					// using expiry month 
					if ($expire_month != ""){
						$objresult = $myObj->UpdateDrvEdate($mac, $expire_month);
						$updatedRet = 1;
					}
					else{
						// update edate or disable it
						if($edate != "" || $editEdate)
						{
							$objresult = $myObj->UpdateDrvEdate($mac, $edate);
							$updatedRet = 1;
						}
					}


					if (($tleft != "" && $tleft > 0)) {

						// case: increase timeleft, unlimited value to limited value
						// need update tmeleft
						$objresult = $myObj->UpdateTimeleft($mac, $tleft);
						$updatedRet = 1;
					}


					// 20100423 - Add checking if from legacy plan
					// 20071211 - Adjust tleft comparison
					// 20071127 - Add bandwidth quota sharing related checking
					//if ( $mac != "" (!$bFromPlan || ($bFromPlan && (($tleft!="" && $tleft>0) || ($bwcount_ul==2 && $bwquota_ul>0) || ($bwcount_dl==2 && $bwquota_dl>0) || ($bwcount_share==2 && $bwquota_share>0))))) {
					if( $mac != "" ){
						if (!$bFromPlan || ($bFromPlan && (($tleft!="" && $tleft>0) || ($bwcount_ul==2 && $bwquota_ul>0) || ($bwcount_dl==2 && $bwquota_dl>0) || ($bwcount_share==2 && $bwquota_share>0)))) {

							$objrsult = $myObj->UpdateThrottle($mac, $throttle_ul, $throttle_dl);
							$updatedRet = 1;
						}
					}

					$myObj = null;
				}

			}
			else			// FirstSpot is stopped
				$updatedRet = 2;
		}
		else{
			// user is not online
		}

		return $updatedRet;
	}

	function writeLog($file, $log)
	{
		$fh = fopen($file, "a");

		if ($fh) {
			flock($fh, LOCK_EX);
			fwrite($fh, $log."\r\n");
			flock($fh, LOCK_UN);
			fclose($fh);
		}
	}

	// 20090708 - Add field type checking to determine whether value need quoting in SQL
	// 08-03-2010 add * during expiry month (emonth, eyear) is set, edate and eminutes will be ignore and set to NULL value (behavior: emonth, eyear is super seed edate and emintes)
	function addUser($username, $password, $fields, $bFieldNumeric){
		return $this->createUser($username, $password, $fields, $bFieldNumeric, null, null);
	}
	
//	function addUser($username, $password, $fields, $bFieldNumeric)
	function createUser($username, $password, $fields, $bFieldNumeric, $isMulti, $isSCode)
	{
		$q="SELECT * FROM $this->usr_table WHERE name = '$username'";
		$result=$this->myDB->query($q);

		if (odbc_fetch_row($result))			// user already exist
			return 2;

		$field_name="";
		$field_value="";

		$field_name="name, pwd";
		if ($password==""){
			$pwd= "NULL";
			$field_value=" '$username', NULL ";
		}
		else{
			// encrypt password
			$pwd = $this->encryptPassword($password);
			$field_value=" '$username', '$pwd'";
		}

		if($isMulti !== null && $isSCode !== null){
			$bFieldNumeric['acctype'] = 1;
			if($isMulti){
				if($isSCode)
					$fields['acctype'] = '4';
				else
					$fields['acctype'] = '3';
			}
			else{
				if($isSCode)
					$fields['acctype'] = '1';
				else
					$fields['acctype'] = 'NULL';
			}
		}

		// checking (will affect another field)
		if (array_key_exists("emonth", $fields) && $fields["emonth"] > 0 && array_key_exists("eyear", $fields) && $fields["eyear"] > 0){
			// ignore edate and eminutes, and set to NULL value
			$fields["edate"] = "";
			$fields["eminutes"] = "";
		}

		$insertFields = array();

		foreach($fields as $k => $v)
			$insertFields[$k] = $v;

		// interpret the update field
		foreach($insertFields as $k => $v){
			$field_name .= ", ".strtolower($k);
			if (strtoupper($v) == "NULL" || $v == "")
				$field_value .=", NULL";
			else if (strtoupper($v) == "Y" || strtoupper($v) == "N")
				$field_value .=", '".strtoupper($v)."'";
			elseif ($bFieldNumeric[$k])
				$field_value .= ", $v";
			else {
				if(preg_match('/^(\d{1,2}-){1,2}\d{4} \d{1,2}:\d{1,2}$/', $v)){ //\\ - 20120824 - edate format error fixing ( with regexp )
					list($date,$time) = explode(" ", $v);
					$v = (String)datetime_from_php($date,$time);
				}
				$field_value .= ", '$v'";
			}
		}

		$q="INSERT INTO $this->usr_table ($field_name) VALUES ($field_value); ";
		$result=$this->myDB->query($q);

		if ($result){
			// check FirstSpot status
			$settingObj = new COM("FSCONFIG.Cfgmgr") or die("editUser.php FSCONFIG.Cfgmgr Object cannot be created!");
			$fs_status = $settingObj->queryService();
			$settingObj = null;

			//query passive login (when macasusr = y and pwd = null)
			if ((isset($insertFields['macasusr']) && strcasecmp($insertFields['macasusr'],"y") == 0) && ($password=="")){
				if ($fs_status=="STARTED")
					$this->PassiveLogin(1, $username); // add
			}
			return 1;
		}
		else
			return 0;
	}


	// userString: one username or "*" (all user)
	// optionFileds[key]: key must be forcedDisconnect, resetQuota
	// forcedDisconnect = 1: before update user attributes, disconnect user first
	// resetQuota = 1: after update user attributes, reset quota
	/* return array (
		success_usr_str: user string which success to update
		success_count: number of user success to update
		fail_usr_str: user string which fail to update
		fail_count: number of user fail to update
		arr_result[name]: array of update_usr_attributes() result 
		result: update_usr_attributes() result, if userString is "*" (all user) return 5
	)*/
	function update_usr_attributes_with_opt($userString, $fields, $bFieldNumeric, $optionFileds = NULL)
	{
		$result_fields = array();

		// option init
		$forcedDisconnect = 0;
		$resetQuota = 0; 
		// set option
		if ($optionFileds !=NULL){
			foreach ($optionFileds as $key => $v){
				if (strcasecmp($key, "forcedDisconnect") == 0 && strtoupper($v) == "Y"){
					$forcedDisconnect = 1;
				}
				else if (strcasecmp($key, "resetQuota") == 0 && strtoupper($v) == "Y"){
					$resetQuota = 1;
				}
			}
		}

		$usrUpdateList = array();

		$updateAllUser = false;

		$success_count = 0;
		$success_usrString = "";
		$fail_count = 0;
		$fail_usrString = "";
		$ret = 0;

		if ($userString == "*" ){
			// all user

			$updateAllUser = true;
			$ret = 5;

			$q="SELECT name FROM $this->usr_table ";
			$result=$this->myDB->query($q);

			$listCount = 0;

			while (odbc_fetch_row($result))
			{
				$name=odbc_result($result,"name");

				$usrUpdateList[$listCount]= $name;
				$listCount++;
			}
		}
		else{
			// one user
			$usrUpdateList[0]= $userString;
		}

		// process

		$arr_result = array();

		foreach($usrUpdateList as $v){
			if ($forcedDisconnect == 1){
				// checking user status
				$temp_chk_fields = array();
				$temp_chk_fields = $this->checkUserStatus($v, 1);

				if ($temp_chk_fields['online_count'] >= 1){ // user is online 
					// disconnect
					$ret_disconnect_fields = $this->disconnectUser($v);
				}
			}
			// update user attributes
			$ret_update = $this->update_usr_attributes($v, $fields, $bFieldNumeric);

			if ($ret_update == 1 ){ // success
				if ($resetQuota == 1){
					$ret_reset = $this->resetQuota($v, 1); // reset quota with live update
				}

				if ($success_count != 0)
					$success_usrString .= ",";

				$success_usrString .= $v;
				$success_count++;
			}
			else{
				// fail
				if ($fail_count != 0)
					$fail_usrString .= ",";

				$fail_usrString .= $v;
				$fail_count++;

			}

			$arr_result[$v] = $ret_update;

			if ($updateAllUser == false){
				$ret = $ret_update;
			}
		}

		$result_fields['success_usr_str'] = $success_usrString;
		$result_fields['success_count'] = $success_count;
		$result_fields['fail_usr_str'] = $fail_usrString;
		$result_fields['fail_count'] = $fail_count;
		$result_fields['arr_result'] = $arr_result;

		$result_fields['result'] = $ret;

		return $result_fields;
	}


	// copy from callAPI.php (checking format)
	//							012345678901234567
	// checking mac 	XX-XX-XX-XX-XX-XX
	function check_mac($v){
		if (!(strpos($v,"-") == 2 && strpos($v,"-", 3) == 5 && strpos($v,"-", 6) ==  8 && strpos($v,"-", 9) == 11 && strpos($v,"-", 12) == 14)){
			return false;
		}
		return true;
	}
	// check ip XXX.XXX.XXX.XXX
	function check_ip($v){

		$arr = Array();
		$arr = explode(".", $v);

		if (count($arr) == 4){
			if (!($arr[0] >= 0 && $arr[0] <255 && $arr[1] >= 0 && $arr[1] <255 && $arr[2] >= 0 && $arr[2] <255 && $arr[3] >= 0 && $arr[3] <255)){
				return false;
			}
		}
		else
			return false;

		return true;
	}

	function exportAllUserLog($usr_log, $ClearLog){
		// default
		$timerange_start=0;
		$timerange_end=time();
		$needTitle = true;
		$this->exportUserLogEx($usr_log, $timerange_start, $timerange_end, $needTitle, $ClearLog);
	}

	function exportUserLogEx($usr_log, $timerange_start, $timerange_end, $needTitle, $ClearLog){
		$message ="";
		if (is_file($usr_log) == true)
			unlink($usr_log);
		if ($needTitle == true && is_file($usr_log) == false) {
			touch ($usr_log);
			$log_msg_heading="Name,IP/MAC,Login time,Logout time,Duration(min),Download Usage,Upload Usage,Total Usage,Login Site\r\n";
			$fileHandler = fopen ($usr_log, 'w');
			fwrite ($fileHandler, $log_msg_heading);
			fclose ($fileHandler);
		}

		$buff = file_get_contents($usr_log);
		$fileHandler = fopen ($usr_log, 'w');

		if (!flock ($fileHandler, LOCK_EX )){ // exclusive lock
			$message.='Fail to lock the file. ';
			$fields['result']= 0;
		}
		else{
			$settingObj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
			$firstspotuserlogtable=$settingObj->getKey('Datasource_Log_Tablename', 'gateway');
			$settingObj=null;

			$query1= "SELECT name, logintime, logouttime, duration, ipormac, reserved10 as logints, reserved11 as logoutts, bwusage, bwusageul, bwusagesha, siteID
					FROM $firstspotuserlogtable WHERE reserved11 >= $timerange_start and reserved11 <= $timerange_end ORDER BY reserved11";


			$result=$this->myDB->query($query1);

			$log_msg_content = '';

			while(odbc_fetch_row($result)) {
				$name=odbc_result($result,'name');
				$logintime=odbc_result($result,'logintime');
				$logouttime=odbc_result($result,'logouttime');
				$duration=odbc_result($result,'duration');
				$macIP=odbc_result($result,'ipormac');
				$bwusage=odbc_result($result,'bwusage');
				$bwusageul=odbc_result($result,'bwusageul');
				$bwusagesha=odbc_result($result,'bwusagesha');
				$siteID=odbc_result($result,'siteID');

				// consider whether the long value of the result
				// is equal or larger than (2 to power 33)-1 
				if($macIP>=8589934890) {
					$macIP_str=make_mac_name($macIP);
				}
else {
					$macIP_str=long2ip(intval(floatval($macIP)));

					// since the bytes of this ip is inverted, we need to reformat it
					$tok = strtok($macIP_str,'.');
					$i=0;
					$ip[$i++]=$tok;

					while($tok){
						$tok = strtok('.');
						$ip[$i++]=$tok;
					}

					if( $macIP_str == '255.255.255.255' || !(isset($ip[3])&&$ip[3]!=''&&$ip[3]!='0') )
						$macIP_str=make_mac_name($macIP);
					else
						$macIP_str="$ip[3].$ip[2].$ip[1].$ip[0]";
				}

				if(isset($duration)&&$duration)
					$duration=round($duration);

				$log_msg_content.="$name,$macIP_str,$logintime,$logouttime,$duration,";

				if($bwusage=='')
					$log_msg_content.='N/A,';
				else
					$log_msg_content.=round($bwusage).'KB,';

				// for upload
				if($bwusageul=='')
					$log_msg_content.="N/A,";
				else 
					$log_msg_content.=round($bwusageul)."KB,";

				//for total
				if($bwusagesha=='')
					$log_msg_content.="N/A,";
				else 
					$log_msg_content.=round($bwusagesha)."KB,";

				// for login site
				//* last field (\r\n), if not then (,)
				if ($siteID=="")
					$log_msg_content.="N/A\r\n";
				else
					$log_msg_content.=$siteID."\r\n";
			}

			fwrite ($fileHandler, $buff.$log_msg_content);
			flock ($fileHandler, LOCK_UN ); // release the lock
			fclose ($fileHandler);

			if(isset($ClearLog)&&($ClearLog==true)){
				$query2 = "DELETE FROM $firstspotuserlogtable ;" ;   //clear userlog table
				$result=$this->myDB->query($query2);
			}

			$fields['result']= 1;
			$fields['filename']= $usr_log;
		}

		$fields['message'] = $message;
		return $fields;
	}

	function exportUrlLogEx($url_log, $timerange_start, $timerange_end){
		// hard code
		$logDirArr = array("..\\log\\archive", "..\\log");
		$csvPrfx = 'urltracking_';
		$csvSufx = '.csv';
		$csvArr = array();

		$message ="";
		if (is_file($url_log) == true)
			unlink($url_log);
		if (is_file($url_log) == false) {
			touch ($url_log);
			$log_msg_heading="name,logtime,mac,ip,url,reserved1,destip,destport\r\n";
			$fileHandler = fopen ($url_log, 'w');
			fwrite ($fileHandler, $log_msg_heading);
			fclose ($fileHandler);
		}

		$buff = file_get_contents($url_log);
		$fileHandler = fopen ($url_log, 'w');

		if (!flock ($fileHandler, LOCK_EX )){ // exclusive lock
			$message.='Fail to lock the file. ';
			$fields['result']= 0;
		}
		else{

			// Extract full path of the CSV files
			foreach ($logDirArr as $l) {
				$fileArr = scandir($l);
				foreach ($fileArr as $f) {
					$filePath = "$l\\$f";
					if (is_file($filePath) && preg_match("/^".$csvPrfx.'[0-9]{4}(.[0-9]{2}){2}_[0-9]{2}(.[0-9]{2}){2}'.$csvSufx.'$/', $f)) {
						$treatFilePath = str_replace($csvSufx, '', $filePath);
						$getPos = strpos($treatFilePath, $csvPrfx, 1) + strlen($csvPrfx);
						if (strpos(substr($treatFilePath, $getPos, strlen($treatFilePath) - $getPos), '_') >0){
							$fileDate = explode('_', substr($treatFilePath, $getPos, strlen($treatFilePath) - $getPos));
							$dateArray = explode('.', $fileDate[0]);
							$timeArray = explode('.', $fileDate[1]);
							$dateTimeStamp = mktime($timeArray[0], $timeArray[1], $timeArray[2], $dateArray[1], $dateArray[2], $dateArray[0]);
							$csvArr[$dateTimeStamp] = $filePath;
						}
					}
				}
			}

			// Read CSV files one by one
			$count = 0;
			$shown = 0;

			fwrite ($fileHandler, $buff);

			foreach ($csvArr as $timestamp => $c) {
				$dataArray = array();
				if ($timestamp >= $timerange_end || $timestamp <= $timerange_start){
					continue;
				}

				$fp = fopen($c, 'rt');

				if ($fp != FALSE) {
					$meetTitle = 0;

					while (($dataArr = fgetcsv($fp, 512, ',', "'")) !== FALSE) {
						// Skip the title line
						if ($meetTitle == 0) {
							$meetTitle = 1;
							continue;
						}
						if (count($dataArr) != 8) { // hard code 8 col 
							continue;
						}

						if ($dataArr[5] >= $timerange_start && $dataArr[5] <= $timerange_end){ // 5: (fsur reserved1 = logging entry time)
							$dataArray[] = $dataArr;
							$count++;
						}
					}

					fclose($fp);
				}

				foreach ($dataArray as $dataArr) {
					fputcsv($fileHandler, $dataArr);
				}

			}
			flock ($fileHandler, LOCK_UN ); // release the lock
			fclose ($fileHandler);

			$fields['result']= 1;
			$fields['filename']= $url_log;
		}

		$fields['message'] = $message;
		return $fields;
	}

	function encryptPassword($password){
		$settingObj = new COM("FSCONFIG.Cfgmgr") or die("fsAPI.php FSCONFIG.Cfgmgr Object cannot be created!");
		$pwd_offload=$settingObj->getKey('pwd_offload', 'gateway');
		$fs_path = $settingObj->getFsPath();
		$def_encrypt_path = $fs_path."dispatcher\\encrypt_pwd.exe";
		$cus_encrypt_path=$settingObj->getKey('encrypt_path', 'gateway');
		$version = $settingObj->getKey('version', 'version');
		$settingObj = null;

		// encrypt password
		$encrypt_pwd="";
		$encrypt_path ="";

		// 20100503 - Bug fix (Miss checking version)
		if (strcasecmp($pwd_offload, "on") == 0 && (strtolower($version) == 'advanced' || strtolower($version) == 'premium' || strtolower($version) == 'trial')) {
			$encrypt_path = $cus_encrypt_path;
		}
		else
			$encrypt_path = $def_encrypt_path;

		$cmd = "\"".$encrypt_path."\" ".$password;

		$sys = new sysfunc();
		$encrypt_pwd = $sys->runCommand($cmd);
		$sys = null;

		return $encrypt_pwd;
	}

	function PHP_getKeyEx($key, $session, $file)
	{
		$result ="";

		$fp = fopen($file,"r");

		if (!$fp) {
			// fail to open file
		}
		else{
			$isMatchSession = false;
			$isMatchKey = false;
			while ( !feof($fp) ) {
				$line = fgets($fp, 1024);

				$startSquarePos = stripos($line, "[");
				$endSquarePos = stripos($line, "]");

				if ($startSquarePos !== false && $endSquarePos !== false){
					// session

					if ($isMatchSession)
						break;

					$removeTagArr = array("[", "]", "\r\n");
					$curr_session = str_replace($removeTagArr, "", $line);
					if (strcmp($curr_session, $session) == 0){
						// match session
						$isMatchSession = true;
					}
					continue;
				}

				if ($isMatchSession){
					// check is it contain =
					if (strstr($line, "=") != NULL){
						list($current_key, $current_value) = explode('=', $line);
						// echo "current_key=".$current_key."\r\n";
						// echo "current_value=".$current_value."\r\n";
						if (strcmp($current_key, $key) == 0){
							// match key
							$isMatchKey = true;
							$result = str_replace("\r\n", "", $current_value);
							break;
						}
					}
				}
			}
			fclose($fp);
		}

		// echo "result=".$result."\r\n";

		return $result;
	}

	function PHP_setKeyEx($value, $key, $session, $file)
	{
		$result = false;

		$fp = fopen($file,"r");

		if (!$fp) {
			// fail to open file
		}
		else{
			$content = "";
			$isMatchSession = false;
			$isMatchKey = false;
			while ( !feof($fp) ) {
				$line = fgets($fp, 1024);

				if ($isMatchKey){
					$content .= $line;
					continue;
				}

				$startSquarePos = stripos($line, "[");
				$endSquarePos = stripos($line, "]");

				if ($startSquarePos !== false && $endSquarePos !== false){
					// session

					if ($isMatchSession){
						$content .= $key."=".$value."\r\n";
						$isMatchKey = true;
						$content .= $line;
						continue;
					}

					$removeTagArr = array("[", "]", "\r\n");
					$curr_session = str_replace($removeTagArr, "", $line);
					if (strcmp($curr_session, $session) == 0){
						// match session
						$isMatchSession = true;
					}
					$content .= $line;
					continue;
				}

				if ($isMatchSession){
					// check is it contain =
					if (strstr($line, "=") != NULL){
						list($current_key, $current_value) = explode('=', $line);
						if (strcmp($current_key, $key) == 0){
							// match key
							$isMatchKey = true;
							// replace 
							$content .= $key."=".$value."\r\n";
							continue;
						}
					}
				}

				$content .= $line;
			}

			fclose($fp);

			if (!$isMatchSession){
				$content .= "[".$session."]\r\n";
				$content .= $key."=".$value."\r\n";
			}
			else if (!$isMatchKey){
				$content .= $key."=".$value."\r\n";
			}

			$fp2 = fopen($file,"w");

			if (!$fp2) {
				// fail to open file
			}
			else{
				if (fwrite($fp2,$content) !== false){
					$result = true;
				}
				fclose($fp2);
			}
		}

		// echo "result=".$result."\r\n";

		return $result;
	}

	// add, remove or update a passive login user
	function PassiveLogin($type, $name){
		$argStr = "";
		if ($type == 0){ // query all passive login
		}
		else if ($type == 1)	// add / update passive login 
			$argStr = " add ".$name;
		else if ($type == 2)	// remove passive login 
			$argStr = " remove ".$name;

		$settingObj = new COM('FSCONFIG.Cfgmgr') or die;
		$cmd = realpath("..\\");
		$cmd .= "\\dispatcher\\QueryPassiveLogin.exe".$argStr;
		$settingObj->runCommand($cmd);
		$settingObj=null;
	}

	//\\ 20130923 >>> 331 - Web Filter
	function WebFilter($action, $domain){
		//	$myobj->EditWebFilter([add|remove|clear|switch], [domain key|on|off|shalla]);
		//	echo "Start Process WF</br>";				//Debug Line
		$result	= "";
		$wf_file = realpath("..\\").'\\BlockedWebPageKey.txt';	// Hard Code
		$myobj	= new COM('FSAUTH.Authserv') or die('info.php FSAUTH.Authserv object cannot be created!');
		$settingObj = new COM("FSCONFIG.Cfgmgr") or die("fsAPI.php FSCONFIG.Cfgmgr Object cannot be created!");
		$fs_status = $settingObj->queryService();
		
		if($action == NULL || $action == "")			// Wrong Input
			return "Empty input error on web filtering process type.";
			
		else if( $action == "clear" ){		// Clear web filtering Entry(skip domain check)
			$wf_file_cont = file_get_contents($wf_file);
			$wf_file_cont = preg_replace("/\[WF START\][\w\W]*\[WF END\]/","[WF START]\r\n[WF END]",$wf_file_cont);
			$fhandle	= fopen($wf_file, "w");
			fwrite($fhandle, $wf_file_cont);
			@fclose($fhandle);

			if($fs_status == "STARTED")
				$myobj->EditWebFilter($action, 'null');

			return true;
		}
		
		else if( $action == "showall"){					// Just for fsapi.exe to display web filtering list
			$contArray	="";
			$wf_file_cont = file_get_contents($wf_file);
			if(strstr($wf_file_cont,"[WF START]\r\n[WF END]")===false){
				$wf_file_cont = preg_match("/\[WF START\]([\w\W]*)\[WF END\]/",$wf_file_cont,$contArray);
				$wf_file_cont = str_replace("\r\n","\n",$contArray[1]);
			}
			else
				$wf_file_cont = "\n(EMPTY)\n";
			return $wf_file_cont;
		}
	
		if($domain == NULL)								// Wrong Input 1
			return "No domain key can be insert to web filtering key list";

		if($action == "switch"){						// Just enable or disable web filtering
			$switcher = 0;
			if(strstr(strtolower($domain),'on')==$domain)
				$switcher = intval(substr($domain, -1));

			$settingObj->setKey($switcher, 'wfilter', 'Web Filter');

			if($fs_status=="STARTED")
				$myobj->EditWebFilter($action, $switcher);

			return true;
		}

		$domainArray = NULL;
		if(is_array($domain)) 	// Check if domain is a list
			$domainArray = $domain;
		else if($domain != "")
			$domainArray[0] = $domain;
		else
			return "Domain key's data type is not correct for web filtering list.";	// Wrong Input 2

	
		$wf_file_cont = file_get_contents($wf_file);
		
		foreach($domainArray as $dArray){	
			if(!preg_match('/^[a-z0-9\*][a-z0-9\.\-]+[a-z0-9\*]$/',$dArray))
				$result	.= "Domain key is not inserted with correct format.\n";
			
			if( $action == "add"){
				if($fs_status=="STARTED")	// Add domain key process
					$myobj->EditWebFilter($action, $dArray);	
			}
			
			else if( $action == "remove" ){					// Remove domain key process(no domain matching type)
				if(strstr($wf_file_cont,"\r\n$dArray\r\n")){
					$wf_file_cont = str_replace("\r\n$dArray\r\n","\r\n",$wf_file_cont);
					if($fs_status=="STARTED")
						$myobj->EditWebFilter($action, $dArray);
					//echo "$wf_file_cont</br>";				//Debug Line
				}
				else
					$result.="[$dArray] is not found from web filtering domain key list.\n";
			}

			else
				return "No such web filtering process type.";	// Wrong Input 3
		}

		// No need to update file content in loop above 
		if($action == "add")
			$wf_file_cont = str_replace("[WF END]",implode("\r\n",$domainArray)."\r\n[WF END]",$wf_file_cont);
		

		//echo "$wf_file_cont</br>";	//Debug Line
	
		$fhandle = fopen($wf_file, "w");
		fwrite($fhandle, $wf_file_cont);
		@fclose($fhandle);

		if($result!="")
			return $result;
		return true;
	}

	//\\ 20140723 >>> Store user information form social network
	//\\ $socialType	-> 1 >> Facebook
	//\\				-> 2 >> Instagram
	//\\				-> 4 >> ?????
	//\\				-> 8 >> ?????
	function addUserInfo($infoArray, $username, $socialType){
		$currentDate	= date("D M d H:i:s Y");
		$socialUpdate	= $infoArray;
		if(!is_array($infoArray)){
			$this->lastErrorMsg	= "User info is not an array data.";
			return false;
		}
		$q="SELECT 1 FROM $this->usr_table WHERE name = '$username'";
		$result=$this->myDB->query($q);

		if(!odbc_fetch_row($result)){			// user does not exist
			$this->lastErrorMsg	= "User is not found from user list.";
			return false;
		}

		$updateQ	= "update $this->usr_snTable set ";
		$insertQ	= "insert into $this->usr_snTable (name, type, data, lastupd) values ";
		foreach($infoArray as $type => $data){
			if(!is_numeric($type) || intval($type) < 0){	// Wrong type
				continue;
			}
			else{
				$q="SELECT 1 FROM $this->usr_snTable WHERE name='$username' and type=$type";
				$result=$this->myDB->query($q);
				if(!odbc_fetch_row($result))				// information is going to be insert
					$q = $insertQ."('$username', $type, '$data', '$currentDate');";
				else										// information is going to be update
					$q = $updateQ."data='$data', lastupd='$currentDate' where name='$username' and type=$type;";
				$q	= str_replace("\'", "''", $q);	// insert or update string with (')
				$this->myDB->query($q);
			}
		}
		return true;
	}

	function getUsrInfoTypes($socialType){
		$this->socialDataType	= array();
		$socialDTypeCount		= 0;
		if(!is_int($socialType)){
			$this->lastErrorMsg	= 'Social Network type is wrong [GET]';
			return false;
		}
		else{
			$q	= "SELECT typename FROM $this->sni_typeTable WHERE sntype = $socialType order by type";
			$result=$this->myDB->query($q);
			while(odbc_fetch_row($result)){
				$type	= odbc_result($result,"typename");
				$this->socialDataType[$socialDTypeCount]	= $type;
				$socialDTypeCount++;
			}
		}
		return true;
	}

	function checkUsrInfoTypes($typeName){
		if($typeName == ''){
			$this->lastErrorMsg	= 'KeyWords is empty';
			return false;
		}
		if(!is_array($this->socialDataType)){
			$this->lastErrorMsg	= 'Social data type is not defined';
			return false;
		}
		foreach($this->socialDataType as $num => $sdtype){
			if(strstr($typeName, $sdtype) == $typeName)
				return $num;
		}
		return -1;
	}

	function addUsrInfoTypes($typename, $socialType){
		if(!is_int($socialType)){
			$this->lastErrorMsg	= 'Social Network type is wrong [ADD]';
			return -1;
		}

		// Create Empty Row With type number
		$q	= "insert into ".$this->sni_typeTable." (type, typename, sntype) select max(type)+1, '', $socialType from $this->sni_typeTable where sntype = $socialType;";
		$result=$this->myDB->query($q);
		if($result){
			// Update Empty Row With new sntype
			$q	= "update ".$this->sni_typeTable." set typename='$typename' where type=(select total from (select max(type)+1 as total from ".$this->sni_typeTable." where typename<>'' and sntype=$socialType) as x) and NOT EXISTS (select m from (select 1 as m from ".$this->sni_typeTable." where typename='$typename' and sntype=$socialType ) as y);";
			$result=$this->myDB->query($q);
			if($result){
				// Remove Empty row when update nothing
				if(odbc_num_rows($result)===0){
					$this->lastErrorMsg	= 'Social Network Account Information Type already updated';
					$q	="Delete from ".$this->sni_typeTable." where sntype=$socialType and type=(select last from (select max(type) as last from ".$this->sni_typeTable." where sntype=$socialType) as x);";
					$this->myDB->query($q);
					return -1;
				}
			}
			else
			{
				$this->lastErrorMsg	= 'Fail to add new social network data type(2)';
				return -1;
			}
		}
		else
		{
			$this->lastErrorMsg	= 'Fail to add new social network data type(1)';
			return -1;
		}
		if($this->getUsrInfoTypes($socialType))
			return $this->checkUsrInfoTypes($typename);
		else
			return -1;
	}

	function phpGetLastError(){
		return $this->lastErrorMsg;
	}

	function getSHMatchKey($isPL = false){
		if($isPL)
			return $this->matchKeyP;
		else
			return $this->matchKeyM;
	}

	// Add new device to multiple login with login once user
	function addAddrToUser($username, $address, $ignore = false)
	{
		$q		= '';
		$result	= 0;
		$loop	= true;
		$tmpKey	= '';
		$tmpVal	= '';
		$count	= 0;

		// check FirstSpot status
		$settingObj	= new COM("FSCONFIG.Cfgmgr") or die("editUser.php FSCONFIG.Cfgmgr Object cannot be created!");
		$fs_status	= $settingObj->queryService();
		$settingObj	= null;

		if($username == NULL || $username == '' || $address == NULL || $address == '')
			return -1;
		//if(!$this->check_mac($address) && !$this->check_ip($address))
		if(!$this->check_mac($address))
			return -2;

		// Get multiple login with login once parent user
		$q="SELECT * FROM $this->usr_table WHERE name = '$username' and macmap = 2 and acctype = 3";
		$result=$this->myDB->query($q);

		// Quit if user does not exist
		if (!odbc_fetch_row($result))
			return -3;

		// Check multiple login limit
		if(!$ignore)
		{
			$uname	= '';
			$limit	= intval(odbc_result($result,"max_logins"));
			if($limit != 0)
			{
				$uCount	= 0;
				$q		= "SELECT * FROM $this->usr_table WHERE name like '$username(%' and macmap = 2 and acctype = 6";
				$unRule	= '/'.$username.'\\([0-9A-F]{2,2}(-[0-9A-F]{2,2}){5,5}\\)/';
				$ruleRlt= 0;
				$rlt2	= $this->myDB->query($q);
				while(odbc_fetch_row($rlt2))
				{
					$uname	= odbc_result($rlt2,"name");
					$ruleRlt= preg_match($unRule, $uname);
					if($ruleRlt === false)
						return -4;
					else if($ruleRlt > 0)
						$uCount++;
				}
				if($uCount >= $limit)
					return -5;
			}
		}

		// new username
		$address2 = str_replace("-", ":", $address);
		$copyAttrStr = "sdate, bwcount, bwcountUL, bwcountSha, btul, btdl, status, startmod, edate, pagenum, acl, roption , rsdate, redate, weeksch, resetopt, ipmap, siteID, iBMsg_glo, iBMsg_per, loginseg, emonth, eyear, portflt, accumbw, accumbwUL, accumbwSha, bwquota, bwquotaUL, bwquotaSha";
		
		$q = "INSERT INTO $this->usr_table (name, reserved1, acctype, macAsUsr, macMap, loginMac, $copyAttrStr) SELECT '$username($address)', NULL, 6, 'Y', 2, ".mac_address_translate($address).", $copyAttrStr FROM $this->usr_table WHERE name = '$username' and not exists (SELECT 1 FROM $this->usr_table WHERE name like '%$address%' or name like '%$address2%');";
		$result = $this->myDB->query($q);

		if (odbc_num_rows($result))
		{
			if ($fs_status=="STARTED")
				$this->PassiveLogin(1, $username.'('.$address.')'); // add or update
			return 255;
		}
		return 0;
	}

}

	function debugAlert($content){
		echo '<script type="text/javascript">alert ("'.$content.'");</script>';
		return;
	}

//exit();												//Debug Line
?>