<?php
// security check
require_once 'secureLogin.php';
// no cache for browser
header('Cache-Control: no-cache, must-revalidate');

$access_parameter = $_SESSION['access_parameter'];
// check category request
// if no request, exit
if (isset($_GET['category']))
    $category = $_GET['category'];
else {
    echo 'No category specified!';
    exit;
}

// all category in setcfg.php
require_once('category.php'); //gather categories information

// check valid category
if (!in_array($category, $arr_category)) {
    echo 'Unknown category!';
    exit;
}

// check access right of non-rootlogin user to a specify category
// if access denied, redirect to login page
if ($rootlogin != 'true') {
    if ($access_parameter{array_search($category, $arr_category) + 1} == '0') {
        // redirect to login page and exit
        header('Location: setlogin.php');
        exit();
    }
}

if ($category=='u') {
    //close session to prevent it from locking session
    //because search user can load for a long time
    session_write_close();
}

// create COM object
$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');

$bt_num_low = $settingobj->getKey('bt_low', 'bw_throttle');
$bt_num_medium = $settingobj->getKey('bt_medium', 'bw_throttle');
$bt_num_high = $settingobj->getKey('bt_high', 'bw_throttle');

// release the COM object
$settingobj=null;

// load menu function
$refresh = '';
// refresh the message window after returned from settingok.php
if ($saved=='true') {
    $saved='false';
    $refresh .= ' parent.mid_right_bottom.location.reload();';
    if ($category=='u'){ // Since in c_User.php use onload() (make dynamic save position)
	    echo "<script type='text/javascript'>parent.mid_right_bottom.location.reload();</script>";
	    $refresh='';
    }
}
if ($category=='p') {
    $refresh .= ' plan_focus();';
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>setcfg.php</title>
<link rel="stylesheet" href="setcfg.css" type="text/css" />
<?php

// 20080318 - Add style sheet for DHCP tab
if ($category == 'u') {
    echo '<link href="users.css" rel="stylesheet" type="text/css" />';
} elseif ($category == 'dhcp') {
    echo '<link href="dhcp.css" rel="stylesheet" type="text/css" />';
}

require_once 'form_elements.php';
/* All the form validation javascript are included from this */
require_once 'validate.php';

?>
<style type="text/css">
<!--
html, body
{
	<?//overflow:	hidden;	//Would be use for live update?>
}
.pageCover, .pageCoverB
{
	top:		0;
	left:		0;
	position:	fixed;
	width:		100%;
	height:		100%;
	display:	none;
}
.pageCover
{
	background:	rgba(0,0,0,.3);
	z-index:	98;
}
.pageCoverB
{
	background:	rgba(255,255,255,.7);
	z-index:	97;
}
.liveUpdateBox
{
	position:	fixed;
	border:		0;
	width:		480px;
	height:		200px;
	z-index:	99;
	display:	none;
}

-->
</style>
</head>
<body onload="<?php echo $refresh?>">
<?php
reset_cm_match();
// include menu
require_once 'menu.php';
reset_cm_match();

// dispatcher
if($category=='d')
{
    require_once 'c_dispatcher.php';
} // end dispatcher


// UI Customization
else if($category=='lang')
{
    require_once 'c_ui_custom.php';
} // End UI Customization


// Authentication Server
else if($category=='a')
{
    require_once 'c_auth.php';
} // end Authentication Server


// Configuration Manager
else if($category=='m')
{
    require_once 'c_cm.php';
} // end Configuration Manager


// Multiple Network Segments
else if($category=='r')
{
    require_once 'setroute.php';
} // end Multiple Network Segments


// Session Handling
else if($category=='s')
{
    require_once 'c_SessionHandling.php';
} // end Session Handling


// dhcp
else if($category=='dhcp')
{
    require_once 'c_dhcp.php';
} // end dhcp


// Exception free websites
else if ($category=='e') {
    require_once 'setfree.php';
} // end Exception free websites


// credit card
else if ($category=='cc')
{
    require_once 'c_CreditCard.php';
} // end Credit card


// User
else if ($category=='u')
{
    require_once 'c_User.php';
} //end User

// Social Network
else if ($category=='sn')
{
    require_once 'c_socialn.php';
} //end Social Network

// Plan
else if ($category=='p')
{
	$disabled = '';
	$version_msg = '';
	$version_star = '';

    echo '<script type="text/javascript" src="./javascript/plan.js"></script>';
    gen_head();
    require_once("setcfg_plan.php");
    gen_foot();
?>
    <script type="text/javascript"><!--
        defaultUI(); // -->
    </script>

    <form action="settingok.php" name="deleteplanform" method="post">
        <input type="hidden" name="listOfPlan">
    </form>
<?php
} // end Plan


// Shopping Cart
else if ($category=='cart')
{
    require_once 'c_Cart.php';
} // end Shopping Cart


// Instant Keywords
else if ($category=='key')
{
    require_once 'c_Key.php';
} // end Instant Keywords


// Bulk Accounts
else if($category=='bcreate')
{
    require_once 'c_BulkAcc.php';
} // end Bulk Accounts


// Status
else if($category=='sstatus')
{
    require_once 'c_Sstatus.php';
} // end Status


// Printing support
else if ($category=='print')
{
    require_once 'c_PrintSup.php';
} // end print service

/*********** Access Control List *********************/
else if ($category=='acl') {
    require_once 'c_ACL.php';
}

//Announcement
else if ($category=='an')
{
    gen_head();
    require_once 'announcement.php';
    gen_foot();
}
else if ($category=='nat')
{
    gen_head();
    require_once 'c_Nat.php';
    gen_foot();
}
else if ($category=='vhosts')
{
    gen_head();
    require_once 'c_VHosts.php';
    gen_foot();
}
else if ($category=='fo')
{
    gen_head();
    require_once 'c_fo.php';
    gen_foot();
}
else if ($category=='flt')
{
    gen_head();
    require_once 'c_Filter.php';
    gen_foot();
}
else if ($category=='ibmsg')
{
	gen_head();
    require_once 'iBMsg.php';
	gen_foot();
}
else if ($category=='report')
{
	gen_head();
    require_once 'report.php';
	gen_foot();
}
else if ($category=='sap')
{
	gen_head();
    require_once 'softap.php';
	gen_foot();
}
else if ($category=='er')
{
	gen_head();
    require_once 'c_EmailReport.php';
	gen_foot();
}

else if ($category=='s_cm') //Display search result
{
	gen_head();
    require_once 'cfgmgr_search.php';
	gen_foot();
}
?>
<div id="pageCover" class="pageCover"></div>
<div id="pageCoverB" class="pageCoverB"></div>
<div id="startCover" class="startCover"></div>
<iframe id="liveUpdateBox" class="liveUpdateBox" src="liveUpgradeBtn.php"></iframe>
</body>
</html>
